#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<time.h>
#include<pthread.h>

#define X 5
#define BROJ_DELOVA 10
#define CEKA 0
#define FARBA 1

pthread_mutex_t mutex;
pthread_cond_t condFarbanje;
pthread_cond_t condSusenje;

int u_susari = 0;
int radnik[2] = {CEKA, CEKA};
int cekanja[BROJ_DELOVA];

int daLiNajduzeCekam(long id) {
    for(int i = 0; i < BROJ_DELOVA; i++) {
        if(cekanja[i] < cekanja[id])
            return 0; // nisi najduze cekao
    }
    return 1; // najduze si cekao
}

void* farbaj(void* i) {
    long id = (long) i;
    int ti = rand() % 10; // vreme dolaska
    int pi = rand() % 3; // povrsina
    int ki = rand() % 3 + 1; // slojevi farbe
    int moj_radnik = -1;
    int s = 1; // vreme susenja

    sleep(ti);
    printf("Deo %ld je stigao u farbaru posle %d vremena, potrebno mu je %d slojeva.\n", id, ti, ki);

    // potrebno je farbati ki puta    
    for(int i = 0; i < ki; i++) {
        pthread_mutex_lock(&mutex);

        cekanja[id] = ti; // kad sam stigao

        // ceka dok oba radnika farbaju druge delove i dok nisi najduze cekao
        while(radnik[0] == FARBA && radnik[1] == FARBA && daLiNajduzeCekam(id) == 0)
            pthread_cond_wait(&condFarbanje, &mutex);
        
        if(radnik[0] == CEKA) {
            radnik[0] = FARBA; // zauzimam radnika
            moj_radnik = 0;
        }
        else {
            radnik[1] = FARBA; // zauzimam radnika
            moj_radnik = 1;
        }

        printf("Radnik %d je POCEO da farba deo %ld.\n", moj_radnik, id);

        pthread_mutex_unlock(&mutex);

        sleep(pi); // radnik farba deo

        // ofarban sloj, oslobadjam radnika
        pthread_mutex_lock(&mutex);
        
        if(moj_radnik == 0)
            radnik[0] = CEKA;
        else 
            radnik[1] = CEKA;

        printf("Radnik %d je OFARBAO deo %ld.\n", moj_radnik, id);
        pthread_cond_broadcast(&condFarbanje);  // obavestenje da je radnik slobodan

        pthread_mutex_unlock(&mutex);

        // nakon svakog sloja farbe deo ide u susaru

        pthread_mutex_lock(&mutex);

        // dok je susara puna i nisam najduze cekao, cekaj
        while(u_susari >= X && daLiNajduzeCekam(id) == 0)
            pthread_cond_wait(&condSusenje, &mutex);

        u_susari++; // ja sam stigao u susaru
        printf("Deo %ld je u susari, trenutno ima %d delova u susari.\n", id, u_susari);

        pthread_mutex_unlock(&mutex);

        sleep(s); // susim se

        pthread_mutex_lock(&mutex);

        u_susari--; // zavrseno susenje
        printf("Deo %ld ima osusen %d. sloj.\n", id, (i + 1));
        pthread_cond_broadcast(&condSusenje); // javljam

        pthread_mutex_unlock(&mutex);
    }

    printf("-----------DEO %ld JE ZAVRSEN.--------------\n", id);

    pthread_exit(NULL);
}

int main() {
    srand(time(NULL));

    pthread_mutex_init(&mutex, NULL);
    pthread_cond_init(&condFarbanje, NULL);
    pthread_cond_init(&condSusenje, NULL);
    pthread_t delovi[BROJ_DELOVA];

    for(int i = 0; i < BROJ_DELOVA; i++)
        cekanja[i] = 100;

    for(long i = 0; i < BROJ_DELOVA; i++)
        pthread_create(&delovi[i], NULL, farbaj, (void*) i);

    for(long i = 0; i < BROJ_DELOVA; i++)
        pthread_join(delovi[i], NULL);

    return 0;
}