#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>

#define N 5 //broj delova
#define x 2 //kapacitet farbare
#define brRadnika 2 //broj radnika u farbari

int farbanja[N];
int spremanZaSusenje[N];
int brDelovaKojiSeFarba = 0;
int brDelovaKojiSeSusi = 0;

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cond = PTHREAD_COND_INITIALIZER;

void *farbaj(void *t)
{
    long tid = (long )t;

    printf("Deo %ld stize u farbaru, potreban broj slojeva farbe %d\n", tid, farbanja[tid]);

    while(farbanja[tid] > 0)
    {
        int p = rand() % 10; //vreme nanosenja farbe
        pthread_mutex_lock(&mutex);
        while(spremanZaSusenje[tid] > 0 || brDelovaKojiSeFarba >= brRadnika)
            pthread_cond_wait(&cond, &mutex);

        brDelovaKojiSeFarba++;
        farbanja[tid]--;
        pthread_mutex_unlock(&mutex);

        printf("Na deo %ld se nanosi sloj farbe %d sec, ostalo je jos %d sloja\n", tid, p, farbanja[tid]);
        sleep(p);

        pthread_mutex_lock(&mutex);
        brDelovaKojiSeFarba--;
        spremanZaSusenje[tid]++;
        pthread_cond_broadcast(&cond);
        pthread_mutex_unlock(&mutex);
    }
}

void *susenje(void *t)
{
    long tid = (long)t;

    while(farbanja[tid] > 0)
    {
        int s = rand() % 10; //vreme susenja
        pthread_mutex_lock(&mutex);

        while(brDelovaKojiSeSusi > x || spremanZaSusenje[tid] == 0)
            pthread_cond_wait(&cond, &mutex);

        brDelovaKojiSeSusi++;
        pthread_mutex_unlock(&mutex);

        printf("Deo %ld se susi %d sec\n", tid, s);
        sleep(s);

        pthread_mutex_lock(&mutex);
        brDelovaKojiSeSusi--;
        spremanZaSusenje[tid]--;
        pthread_cond_broadcast(&cond);
        pthread_mutex_unlock(&mutex);
    }
}

int main()
{
    pthread_t threads[N];

    srand(time(NULL));

    int k;
    for(int i = 0; i < N; i++)
    {
        k = (rand() % 5) + 1; //broj slojeva farbe
        farbanja[i] = k;
        spremanZaSusenje[i] = 0;
    }

    for(long i = 0; i < N; i++)
        pthread_create(&threads[i], NULL, farbaj, (void *) i);

    for(long i = 0; i < N; i++)
        pthread_create(&threads[i], NULL, susenje, (void *) i);

    for(long i = 0; i < N; i++)
        pthread_join(threads[i], NULL);

    pthread_exit(NULL);
    return 0;
}