#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

#define I 5 // broj delova
#define S 1 // sekundi za susenje
#define X 2 // max 2 dela u susari u jednom trenutku

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t condF = PTHREAD_COND_INITIALIZER;
pthread_cond_t condS = PTHREAD_COND_INITIALIZER;

int radnikFarbanje = 0;
int radnikSusare = 0;

void *work(void *t)
{
    long id = (long)t;
    int pi = rand() % 5 + 1; // povrsina dela, sekundi potrebno za farbanje {1-5}
    int ki = rand() % 3 + 1; // broj slojeva za farbanje {1-3}
    int ti = rand() % 5; // dolazi za ti sekundi

    sleep(ti);
    printf("[%ld] je stigao do trake za %d sec.Farbam se %d puta\n",id,ti,ki);

    while(ki > 0)
    {
        pthread_mutex_lock(&mutex);
        while(radnikFarbanje >= 2)
            pthread_cond_wait(&condF,&mutex);

        radnikFarbanje++;       
        pthread_mutex_unlock(&mutex);

        printf("[%ld] se farba narednih %d sec...\n",id,pi);
        sleep(pi);

        pthread_mutex_lock(&mutex);
        radnikFarbanje--;
        if(radnikFarbanje < 2)
            pthread_cond_broadcast(&condF);

        while(radnikSusare >= X)
            pthread_cond_wait(&condS,&mutex);
        
        radnikSusare++;
        pthread_mutex_unlock(&mutex);

        printf("[%ld] se susi narednih %d sec...\n",id,S);
        sleep(S);

        pthread_mutex_lock(&mutex);
        radnikSusare--;
        pthread_cond_broadcast(&condS);
        pthread_mutex_unlock(&mutex);      
        ki--;
    }
    printf("[%ld] Zavrsio sam posao.\n",id);
    pthread_exit(NULL);
}

int main()
{
    pthread_t delovi[I];

    for(long i=0;i < I;i++)
        pthread_create(delovi + i,NULL,work,(void *)i);

    pthread_exit(NULL);
}