#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdbool.h>
#include <pthread.h>
#include <limits.h>

#define N 10
#define X 3
#define S 15
#define NE_RADI 0

int brZauzetihRadnika = 0;
int brZauzetihSusara = 0;
int *susara;
int *vremena;

pthread_t *delovi;

pthread_mutex_t farbanjeMutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t farbanjeCond = PTHREAD_COND_INITIALIZER;
pthread_mutex_t susenjeMutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t susenjeCond = PTHREAD_COND_INITIALIZER;

bool najmanjeVreme(int id)
{
    int index = -1;
    int min = INT_MAX;

    for (int i = 0; i < N; i++)
    {
        if (vremena[i] < min)
        {
            min = vremena[i];
            index = i;
        }
    }

    return index == id;
}

void* farbanje(void *arg)
{
    int id = *((int*)arg);
    int t = rand() % 60;
    int p = rand() % 2 + 11;
    int k = rand() % 3 + 1;
    int mesto = -1;

    vremena[id] = t;
    sleep(t);

    for (int i = 0; i < k; i++)
    {
        // FARBANJE
        printf("%d ceka farbanje\n", id);
        pthread_mutex_lock(&farbanjeMutex);
        while (brZauzetihRadnika >= 2 && !najmanjeVreme(id))
            pthread_cond_wait(&farbanjeCond, &farbanjeMutex);
        
        brZauzetihRadnika++;
        printf("%d se farba BROJ FARBANJA %d\n", id, brZauzetihRadnika);

        pthread_mutex_unlock(&farbanjeMutex);
        pthread_cond_broadcast(&farbanjeCond);  
        
        sleep(p);    
        vremena[id] += p;

        pthread_mutex_lock(&farbanjeMutex);
        
        brZauzetihRadnika--;
        printf("%d zavrsio farbanje BROJ FARBANJA %d\n", id, brZauzetihRadnika);

        pthread_mutex_unlock(&farbanjeMutex);
        pthread_cond_broadcast(&farbanjeCond);

        // SUSENJE
        printf("%d ceka susenje\n", id);
        pthread_mutex_lock(&susenjeMutex);
        while (brZauzetihSusara >= X && !najmanjeVreme(id))
            pthread_cond_wait(&susenjeCond, &susenjeMutex);  
        
        brZauzetihSusara++;
        printf("%d se susi BROJ SUSENJA %d\n", id, brZauzetihSusara);
        for (int i = 0; i < X; i++)
        {
            if (susara[i] == NE_RADI)
            {
                susara[i] = id;
                mesto = i;
                break;
            }
        }

        pthread_mutex_unlock(&susenjeMutex);
        pthread_cond_broadcast(&susenjeCond);

        sleep(S);
        vremena[id] += S;

        pthread_mutex_lock(&susenjeMutex);

        brZauzetihSusara--;
        susara[mesto] = NE_RADI;
        printf("%d zavrsio susenje BROJ SUSENJA %d\n", id, brZauzetihSusara);

        pthread_mutex_unlock(&susenjeMutex);
        pthread_cond_broadcast(&susenjeCond);
    }
}

int main()
{
    susara = (int*) malloc(X * sizeof(int));
    vremena = (int*) malloc(N * sizeof(int));

    for (int i = 0; i < X; i++)
    {
        susara[i] = NE_RADI;
    }

    for (int i = 0; i < X; i++)
    {
        vremena[i] = INT_MAX;
    }

    delovi = (pthread_t*) malloc(N * sizeof(pthread_t));

    for (int i = 0; i < N; i++)
    {
        pthread_create(&delovi[i], NULL, farbanje, (void*)&i);
    }

    for (int i = 0; i < N; i++)
    {
        pthread_join(delovi[i], NULL);
    }

    return 0;
}