#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>
#include<unistd.h>

#define N 10
#define x 3
#define s 2

#define SLOBODAN 0
#define ZAUZET 1

pthread_mutex_t mutexRadnik, mutexSusara;
pthread_cond_t condRadnik, condSusara;

int radnikFarbanje1 = SLOBODAN;
int radnikFarbanje2 = SLOBODAN;
int susara = 0;

void *farbanje(void *arg)
{
    long id = (long)arg;
    int vreme = rand()%60;
    int p = rand()%5;
    int k = rand()%4;
    int pom = 1;

    sleep(vreme);
    printf("Deo %ld je stigao u fabriku u vremenskom trenutku %d\n", id, vreme);

    while(pom <= k)
    {   
        printf("Deo %ld ceka na farbanje %d put\n", id, pom);
        pthread_mutex_lock(&mutexRadnik);

        while(radnikFarbanje1==ZAUZET && radnikFarbanje2==ZAUZET)
            pthread_cond_wait(&condRadnik, &mutexRadnik);

        int ind;
        if(radnikFarbanje1==SLOBODAN)
        {
            radnikFarbanje1 = ZAUZET;
            ind = 1;
        }
        else 
        {
            radnikFarbanje2 = ZAUZET;
            ind = 2;
        }
        pthread_mutex_unlock(&mutexRadnik);

        int vremeFarbanja = p; 
        printf("Deo %ld ide na farbanje koje ce trajati %d\n", id, vremeFarbanja);
        sleep(vremeFarbanja);
        printf("Zavrseno je farbanje dela %ld\n", id);

        pthread_mutex_lock(&mutexRadnik);
        if(ind==1)
        {
            radnikFarbanje1 = SLOBODAN;
            pthread_cond_broadcast(&condRadnik);
        }
        else if(ind==2)
        {
            radnikFarbanje2 = SLOBODAN;
            pthread_cond_broadcast(&condRadnik);
        }
        pthread_mutex_unlock(&mutexRadnik);

        printf("Deo %ld ceka susenje\n", id);
        
        pthread_mutex_lock(&mutexSusara);
        while( susara == x )
            pthread_cond_wait(&condSusara, &mutexSusara);
        susara++;
        pthread_mutex_unlock(&mutexSusara);

        printf("Deo %ld ide na susenje koje ce trajati %d\n", id, s);
        sleep(s);
        printf("Deo %ld se osusio za vreme %d\n", id, s);

        pthread_mutex_lock(&mutexSusara);
        susara--;
        pom++;
        pthread_cond_broadcast(&condSusara);
        pthread_mutex_unlock(&mutexSusara);
    }
}

int main()
{
    pthread_t t[N];

    pthread_cond_init(&condRadnik, NULL);
    pthread_cond_init(&condSusara, NULL);

    pthread_mutex_init(&mutexRadnik, NULL);
    pthread_mutex_init(&mutexSusara, NULL);

    for(long i=0; i<N; i++)
        pthread_create(t+i, NULL, farbanje, (void*)i);

    for(long i=0; i<N; i++)
        pthread_join(t[i], NULL);

    return 0;
}