#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<pthread.h>

#define BROJDELOVA 10
#define KAPACITETHLADNJACE 3
#define SUSENJE 2 //susenje svakog

pthread_mutex_t mutex;
pthread_cond_t cond, condSusara;
long cekaonica[BROJDELOVA];  // -1 nema niko, -2 uzet deo else id nekog dela
int uSusari = 0;

int dajPrvoSlobodnoMesto(){
    for(int i=0;i<BROJDELOVA;i++)
        if(cekaonica[i] == -1)
            return i;
}
int dajMiDeo(){
    int brojac = 0;
    for(int i=0;i<BROJDELOVA;i++){
        if(cekaonica[i] >= 0)
            return i;
        if(cekaonica[i] == -2)
            brojac ++;
    }
    if(brojac == BROJDELOVA)
        return -3;  // kraj posla

    return -1;  //nema dela za rad
}

void* ponasanjeRadnika(void* arg){
    long id = (long) arg;
    
    while(1){
        int pozicijaDela;
        pthread_mutex_lock(&mutex);
        while((pozicijaDela=dajMiDeo()) == -1)
            pthread_cond_wait(&cond, &mutex);
        if(pozicijaDela < 0){
            pthread_mutex_unlock(&mutex);  
            break;
        }
        long idDelaKojiObradjujem = cekaonica[pozicijaDela]; 
        cekaonica[pozicijaDela] = -2;   //uzet deo;
        pthread_mutex_unlock(&mutex);

        int povrsinaDela = rand()%10 + 1;   // povrsina dela koji cu da farbam pi -> kolika je povrsina toliko ga i garbam sekundi tj = pi
        int slojeviFarbe = rand()%5 + 1;    // maksimalno je 5 slojeva po delu.
        int tempFarbanja = 0;

        while(tempFarbanja<slojeviFarbe){
            tempFarbanja ++;
            printf("Radnik %ld krece farbanje dela %ld - povrsine %d - %d put.\n" , (id+1) ,idDelaKojiObradjujem, povrsinaDela, tempFarbanja);
            sleep(povrsinaDela);
            printf("Radnik %ld ofarban deo %ld - povrsine %d \n" , (id+1) ,idDelaKojiObradjujem, povrsinaDela);

            pthread_mutex_lock(&mutex);
            while((uSusari+1) == uSusari)
                pthread_cond_wait(&condSusara, &mutex);
            uSusari++;
            pthread_mutex_unlock(&mutex);
            printf("Susi se deo %ld\n", idDelaKojiObradjujem);
            sleep(SUSENJE);
            pthread_mutex_lock(&mutex);
            uSusari --;
            pthread_cond_signal(&condSusara);
            pthread_mutex_unlock(&mutex);
        }
    }
    pthread_exit(0);
}

void* dolazenjeDelovaUFabriku(void* arg){
    long id = (long) arg;
    sleep((rand()%5)+1);
    pthread_mutex_lock(&mutex);
        int mesto = dajPrvoSlobodnoMesto();
        cekaonica[mesto] = id;
        pthread_cond_broadcast(&cond);
    pthread_mutex_unlock(&mutex);
    printf("Deo %ld je stigao u farbaru. \n", id);
    pthread_exit(0);
}

int main(){
    srand(time(NULL));
    pthread_mutex_init(&mutex, NULL);
    pthread_cond_init(&cond, NULL);
    pthread_cond_init(&condSusara, NULL);

    for(int i=0;i<BROJDELOVA; i++){
        cekaonica[i] = -1;
    }

    pthread_t radnici[2];
    for(long i=0;i<2;i++)
        pthread_create(radnici + i, NULL, ponasanjeRadnika, (void *)i);

    pthread_t delovi[BROJDELOVA];
    for(long i=0;i<BROJDELOVA;i++)
        pthread_create(delovi + i, NULL, dolazenjeDelovaUFabriku, (void *)i);

    for(long i=0;i<2;i++)
        pthread_join(radnici[i], NULL);

    pthread_exit(0);
    return 0;
}
