#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>

#define BROJ_DELOVA 10
#define VREME_U_SUSARI 2
#define KAPACITET_SUSARE 3

#define BROJ_RADNIKA 2

pthread_mutex_t mutex;
pthread_cond_t condCekajRadnika;
pthread_cond_t condCekajMestoUSusari;

int brojZauzetihRadnika = 0;
int brojDelovaUSusari = 0;

void* farbaj (void* args){
	long id = (long) args;	

	while(1){
		long vremeDolaskaDela = rand() % 11;
		long povrsina = rand() % 11 + 1; //Povrsina dela i ujedno vreme farbanja dela
		int potrebanBrojSlojeva = rand() % 5 + 1; //Broj slojeva farbe

		sleep(vremeDolaskaDela); //Ceka se da pristigne deo
		printf("Deo %ld pristigao u farbaru. Treba da se predje %d slojeva.\n", id, potrebanBrojSlojeva);
		
		for (int i = 0; i < potrebanBrojSlojeva; i++){
			//Ukoliko su radnici zauzeti cekaj da se oslobode
			pthread_mutex_lock(&mutex);

			while (brojZauzetihRadnika == BROJ_RADNIKA)
				pthread_cond_wait(&condCekajRadnika, &mutex);

			//Postoji radnik koji je slobodan, daj mu zadatak 
			brojZauzetihRadnika++;
			printf("-> BROJ ZAUZETIH RADNIKA: %d\n", brojZauzetihRadnika);

			pthread_mutex_unlock(&mutex);
		
			//Pocni sa farbanjem
			printf("U toku je farbanje %ld dela %d. sloja koje traje %ld sekundi.\n", id, i + 1, povrsina);
			sleep(povrsina);
			
			//Zavrsen proces farbanja
			pthread_mutex_lock(&mutex);

			//Oslobodi radnika koji je farbao ovaj deo i obavesti onog ko ceka radnika 
			brojZauzetihRadnika--;
			printf("-> BROJ ZAUZETIH RADNIKA: %d\n", brojZauzetihRadnika);

			printf("Zavrseno farbanje %ld dela %d sloja.\n", id, i + 1);
			
			if (brojZauzetihRadnika != BROJ_RADNIKA)
				pthread_cond_broadcast(&condCekajRadnika);

			pthread_mutex_unlock(&mutex);

			//Pokusaj da ubacis deo u susaru
			pthread_mutex_lock(&mutex);

			while (brojDelovaUSusari == KAPACITET_SUSARE)
				pthread_cond_wait(&condCekajMestoUSusari, &mutex);
			
			//Oslobodilo se mesto u susari
			brojDelovaUSusari++;
			printf("-> BROJ DELOVA U SUSARI: %d\n", brojDelovaUSusari);

			pthread_mutex_unlock(&mutex);

			printf("Deo %ld je u susari.\n", id);
			sleep(VREME_U_SUSARI); //SUSENJE
			printf("Deo %ld je zavrsio sa susenjem %d. sloja\n", id, i + 1);

			//Zavrseno je sa susenjem
			pthread_mutex_lock(&mutex);

			brojDelovaUSusari--;
			printf("-> BROJ DELOVA U SUSARI: %d\n", brojDelovaUSusari);

			if(brojDelovaUSusari != KAPACITET_SUSARE)
				pthread_cond_broadcast(&condCekajMestoUSusari);

			pthread_mutex_unlock(&mutex);
			
		}

		printf("*** DEO %ld JE U POTPUNOSTI OBRADjEN. ***\n", id);
	}
}

int main(){
	pthread_t *delovi = (pthread_t*) malloc (BROJ_DELOVA * sizeof(pthread_t));

	pthread_mutex_init (&mutex, NULL);	
	pthread_cond_init (&condCekajRadnika, NULL);
	pthread_cond_init (&condCekajMestoUSusari, NULL);

	for (long i = 0; i < BROJ_DELOVA; i++)
		pthread_create (&delovi[i], NULL, farbaj, (void*) i);

	for (long i = 0; i < BROJ_DELOVA; i++)
		pthread_join(delovi[i], NULL);

	pthread_mutex_destroy (&mutex);
	pthread_cond_destroy (&condCekajRadnika);
	pthread_cond_destroy (&condCekajMestoUSusari);
	
	return 0;
}
