#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <time.h>

#define N 6
#define X 1
#define S 2
#define WORKERS 2
#define NONE -1

int waitingForWorkers = 0;
int waitingForDryer = 0;
int workers = 0;
int dryer = 0;

pthread_mutex_t workersMutex = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t dryerMutex = PTHREAD_MUTEX_INITIALIZER;

pthread_cond_t workersCond = PTHREAD_COND_INITIALIZER;
pthread_cond_t dryerCond = PTHREAD_COND_INITIALIZER;

int waitingTimeWorkers[N];
int waitingTimeDryer[N];

int canUnlock(long id, int *waitingTimes)
{
    for (int i = 0; i < N; i++) if (waitingTimes[i] != NONE && waitingTimes[id] > waitingTimes[i]) return 0;
    return 1;
}

void *f(void *arg)
{
    long id = (long)arg;
    int p = rand() % 3 + 1;
    int k = rand() % 5 + 1;
    sleep(rand() % 15);

    printf("%ld: Stigao u farbaru za %d farbanja od %ds.\n", id, k, p);

    while (k > 0)
    {
        printf("%ld: Ceka farbanje\n", id);
        pthread_mutex_lock(&workersMutex);
        waitingForWorkers++;
        waitingTimeWorkers[id] = time(NULL);

        while (workers == WORKERS || (workers < WORKERS && waitingForWorkers > 0 && !canUnlock(id, waitingTimeWorkers))) pthread_cond_wait(&workersCond, &workersMutex);
        waitingForWorkers--;
        workers++;
        waitingTimeWorkers[id] = -1;

        pthread_mutex_unlock(&workersMutex);

        printf("%ld: Stigao na farbanje...\n", id);
        sleep(p);
        printf("%ld: Zavrsio farbanje.\n", id);

        pthread_mutex_lock(&workersMutex);
        workers--;
        pthread_cond_broadcast(&workersCond);
        pthread_mutex_unlock(&workersMutex);

        printf("%ld: Ceka susenje\n", id);
        pthread_mutex_lock(&dryerMutex);
        waitingForDryer++;
        waitingTimeDryer[id] = time(NULL);

        while (dryer == X || (dryer < X && waitingForDryer > 0 && !canUnlock(id, waitingTimeDryer))) pthread_cond_wait(&dryerCond, &dryerMutex);
        waitingForDryer--;
        dryer++;
        waitingTimeDryer[id] = -1;
        
        pthread_mutex_unlock(&dryerMutex);

        printf("%ld: Stigao na susenje...\n", id);
        sleep(S);
        printf("%ld: Zavrsio susenje, preostalo %d farbanja.\n", id, k-1);

        pthread_mutex_lock(&dryerMutex);
        dryer--;
        pthread_cond_broadcast(&dryerCond);
        pthread_mutex_unlock(&dryerMutex);
        k--;
    }

    printf("%ld: Izasao iz farbare.\n", id);
    pthread_exit(NULL);
}

int main()
{
    srand(time(NULL));
    pthread_t parts[N];
    for (int i = 0; i < N; i++)
    {
        waitingTimeWorkers[i] = NONE;
        waitingTimeDryer[i] = NONE;
    }
    for (long i = 0; i < N; i++) pthread_create(parts + i, NULL, f, (void*)i);

    pthread_exit(NULL);
}