#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

#define SLOBODAN 0
#define ZAUZET 1

#define MAX_DELOVA_U_SUSARI 5
#define MAX_SLOJEVA_FARBE 4

#define P 4 //max vrednost povrsine (pi) nekog dela i vremena farbanja tog istog dela
#define S 2 //vreme susenja u susari

#define BROJ_DELOVA 8
#define T 10 //max moguc trenutak dolaska dela 

pthread_mutex_t mutex;
pthread_cond_t condFarbanje, condSusenje;

int radnici[2];
int brojDelovaUSusari;

void *work(void *arg)
{
	long id = (long)arg;
	
	int pi = rand()%P+1; //jer ne moze da ima povrsinu 0
	int ki = rand()%MAX_SLOJEVA_FARBE+1; //jer ne moze da ima 0 slojeva farbe
	int mojRadnik = -1;
	int gotov = 0;
	
	sleep(rand()%T+1);
	printf("Deo %ld je stigao za farbanje. Povrsina dela je %d. Imace %d slojeva farbe, koji se farbaju po %d s\n",id,pi,ki,pi);
	
	while(gotov<ki) //dok ne ofarbamo dovoljno slojeva
	{
		pthread_mutex_lock(&mutex);
		while(radnici[0] == ZAUZET && radnici[1]==ZAUZET) //cekamo ako su oba radnika zauzeta
			pthread_cond_wait(&condFarbanje,&mutex);
		
		//gledamo koji je radnik slobodan da uzme deo
		if(radnici[0] == SLOBODAN) 
		{
			radnici[0] = ZAUZET;
			mojRadnik = 0;
		}
		else if(radnici[1] == SLOBODAN) 
		{
			radnici[1] = ZAUZET;
			mojRadnik = 1;
		}
		//zuzeli smo radnika
		pthread_mutex_unlock(&mutex);
		
		printf("Deo %ld je na farbanju.\n",id);
		sleep(pi);
		
		printf("Deo %ld je zavrsio farbanje i ceka na susaru.\n",id);
		
		//posle farbanja ide u susaru
		pthread_mutex_lock(&mutex);
		
		radnici[mojRadnik]=SLOBODAN; //nas radnik je sad slobodan drugi deo da farba
		pthread_cond_broadcast(&condFarbanje); //javljamo da je radnik oslobodjen
		
		while(brojDelovaUSusari==MAX_DELOVA_U_SUSARI) //cekamo da bude mesta u susari
			pthread_cond_wait(&condSusenje,&mutex);
				
		brojDelovaUSusari++; //usli smo u susaru
		pthread_mutex_unlock(&mutex);
		
		printf("Deo %ld je u susari\n",id);
		sleep(S); //susenje
			
		pthread_mutex_lock(&mutex);
		brojDelovaUSusari--; //izlazimo iz susare
		pthread_cond_broadcast(&condSusenje); //javljamo da moze drugi deo u susaru
		pthread_mutex_unlock(&mutex);
		
		gotov++; //dodat i osusen sloj farbe
		printf("Deo %ld je ofarban i susen %d puta\n",id,gotov);
	}
	printf("Deo %ld je gotov\n",id);
}

int main()
{
	pthread_t t[BROJ_DELOVA];
	
	pthread_mutex_init(&mutex,NULL);
	pthread_cond_init(&condFarbanje,NULL);
	pthread_cond_init(&condSusenje,NULL);
	
	radnici[0]=SLOBODAN;
	radnici[1]=SLOBODAN;
	brojDelovaUSusari = 0;
	
	for(long i=0;i<BROJ_DELOVA;i++)
		pthread_create(t+i,NULL,work,(void*)i);
		
	for(int i=0;i<BROJ_DELOVA;i++)
		pthread_join(t[i],NULL);
		
	return 0;
}
