#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>
#include<unistd.h>
#include<time.h>

#define N 10 //broj delova
#define s 2 //vreme potrebno za susenje
#define x 2 //kapacitet susare

pthread_mutex_t mutexFarbanje, mutexFarbanje2, mutexSusenje;
pthread_cond_t condSusenje;

int brojNaFarbanju = 0;
int brojNaSusenju = 0;

void *workRadnik1(void *arg)
{
	long id = (long)arg;
	
	int p = rand() % 10 + 1; //povrsina
	int k = rand() % 3 + 1; //broj slojeva
	int vreme = rand() % 5;

	sleep(vreme);
	printf("Deo %ld stize u farbaru u trenutku: %d i potrebno je naneti %d slojeva farbe.\n", id, vreme, k);
	
	while(k > 0){
		pthread_mutex_lock(&mutexFarbanje);
			sleep(p);
			printf("Deo %ld je ofarban.\n", id);
		pthread_mutex_unlock(&mutexFarbanje);
		
		pthread_mutex_lock(&mutexSusenje);
			while(brojNaSusenju >= x)		
				pthread_cond_wait(&condSusenje, &mutexSusenje);
			brojNaSusenju++;
		pthread_mutex_unlock(&mutexSusenje);
		
		sleep(s);
		printf("Deo %ld izlazi iz susare.\n", id);

		pthread_mutex_lock(&mutexSusenje);
			brojNaSusenju--;
			pthread_cond_signal(&condSusenje);
		pthread_mutex_unlock(&mutexSusenje);
		
		k--;
	}
	pthread_exit(NULL);
}

void *workRadnik2(void *arg)
{
	long id = (long)arg;
	
	int p = rand() % 10 + 1; //povrsina
	int k = rand() % 3 + 1; //broj slojeva
	int vreme = rand() % 5;

	sleep(vreme);
	printf("Deo %ld stize u farbaru u trenutku: %d i potrebno je naneti %d slojeva farbe.\n", id, vreme, k);
	
	while(k > 0){
		pthread_mutex_lock(&mutexFarbanje2);
			sleep(p);
			printf("Deo %ld je ofarban.\n", id);
		pthread_mutex_unlock(&mutexFarbanje2);

		pthread_mutex_lock(&mutexSusenje);
			while(brojNaSusenju >= x)		
				pthread_cond_wait(&condSusenje, &mutexSusenje);
			brojNaSusenju++;
		pthread_mutex_unlock(&mutexSusenje);
		
		sleep(s);
		printf("Deo %ld izlazi iz susare.\n", id);

		pthread_mutex_lock(&mutexSusenje);
			brojNaSusenju--;
			pthread_cond_signal(&condSusenje);
		pthread_mutex_unlock(&mutexSusenje);
		
		k--;
	}
	pthread_exit(NULL);
}

int main()
{
	pthread_t niti[N];

	pthread_mutex_init(&mutexFarbanje, NULL);
	pthread_mutex_init(&mutexFarbanje2, NULL);
	pthread_mutex_init(&mutexSusenje, NULL);
	pthread_cond_init(&condSusenje, NULL);

	for(long i = 0; i < N; i++){
		if(i%2 == 0)
			pthread_create(niti + i, NULL, workRadnik1, (void*)i);
		else
			pthread_create(niti + i, NULL, workRadnik2, (void*)i);
	}
	for(long i = 0; i < N; i++)
		pthread_join(niti[i], NULL);

	return 0;
}

//dva radnika farbaju, a susara je sama za sebe
//farba se k * p sekundi jedan deo
//ne farba se jos jedan sloj ako ne moze da se osusi
