#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>

#define N 10 // broj delova 
#define X 3 // kapacitet susare 
#define S 1 // vreme potrebno za susenje
#define Y 2 // kapacitet farbare 
typedef enum Operacija {SUSENJE, FARBANJE} OPERACIJA; 
typedef struct Deo {
	int p; 
	int k; 
	int ofarbano;  
	OPERACIJA operacija; 
}DEO; 
DEO delovi[N]; 

int koristiSusaru = 0; 
int koristiFarbaru = 0; 

pthread_mutex_t lockSusara; 
pthread_mutex_t lockFarbara; 

pthread_cond_t condSusara; 
pthread_cond_t condFarbara; 

void farbajDeo(long id){
	pthread_mutex_lock(&lockFarbara); 
	while(koristiFarbaru == Y)
		pthread_cond_wait(&condFarbara, &lockFarbara); 
	koristiFarbaru++; 	
	pthread_mutex_unlock(&lockFarbara); 
	
	printf("Deo %ld => Poceto farbanje %d. dela \n", id, delovi[id].ofarbano+1); 
	sleep(delovi[id].p); 
	printf("Deo %ld => Zavrseno farbanje %d. dela \n", id, delovi[id].ofarbano+1); 
	delovi[id].operacija = SUSENJE; 
	
	pthread_mutex_lock(&lockFarbara); 
	koristiFarbaru--;
	pthread_cond_broadcast(&condFarbara);  	
	pthread_mutex_unlock(&lockFarbara); 
}
void susiDeo(long id){
	pthread_mutex_lock(&lockSusara); 
	while(koristiSusaru == X)
		pthread_cond_wait(&condSusara, &lockSusara); 
	koristiSusaru++; 	
	pthread_mutex_unlock(&lockSusara); 
	
	printf("Deo %ld => Poceto susenje %d. dela \n", id, delovi[id].ofarbano+1); 
	sleep(S); 
	printf("Deo %ld => Zavrseno susenje %d. dela \n", id, delovi[id].ofarbano+1); 
	
	delovi[id].ofarbano++; 
	delovi[id].operacija = FARBANJE; 
	
	pthread_mutex_lock(&lockSusara); 
	koristiSusaru--;
	pthread_cond_broadcast(&condSusara);  	
	pthread_mutex_unlock(&lockSusara);
}
void * izvrsiOperaciju(void * arg){
	long id = (long) arg; 
	sleep(rand()%5+1); // minimum ceka 1 sek pre nego sto stigne
	printf("Deo %ld je stigao\tVreme p: %d\t Farbanja k:%d\n", id, delovi[id].p, delovi[id].k); 
	while(delovi[id].ofarbano < delovi[id].k){
		if(delovi[id].operacija == FARBANJE)
			farbajDeo(id); 
		else
			susiDeo(id); 
	}
	printf("\tDeo %ld je zavrsen\n", id); 
}
int main(){
	
	pthread_t procesi[N];
	long i; 
	
	pthread_mutex_init(&lockFarbara, NULL); 
	pthread_mutex_init(&lockSusara, NULL); 
	
	pthread_cond_init(&condFarbara, NULL); 
	pthread_cond_init(&condSusara, NULL); 
	for(i=0; i<N; i++){ 
		// namerno je dodato +1 kako povrsina i broj slojeva dela ne bi bile 0
		delovi[i].p = rand()%5+1; // koliko dugo se farba deo
		delovi[i].k = rand()%5+1; // koliko puta se farba deo
		delovi[i].operacija = FARBANJE;  
		delovi[i].ofarbano = 0; 
	}
	
	for(i=0; i<N; i++)
		pthread_create(procesi + i, NULL, izvrsiOperaciju, (void *) i); 
	
	for(i=0; i<N; i++) 
		pthread_join(procesi[i], NULL); 
		
	return 0; 
}
