
#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<pthread.h>

#define brDelova 30
#define kapacitetSusare 10
#define s 2 //potrebno stanje za susenje
#define brRadnika 2

pthread_mutex_t mutexSusenje;
pthread_mutex_t mutexFarbanje;
pthread_cond_t condFarbanje;
pthread_cond_t condSusenje;

int zauzetostFarbare=0;
int zauzetostSusare=0;

int vreme[brDelova];
int povrsina[brDelova];
int brSlojevaFarbe[brDelova];

void *farbanje(void *arg)
{
	long id=(long)arg;

	vreme[id]=rand()%10;
	povrsina[id]=rand()%5+1;
	brSlojevaFarbe[id]=rand()%4+1;
	
	sleep(vreme[id]);
	printf("Deo %ld sa %d slojeva za farbanje i povrsinom %d stize u farbaru u trenutku %d\n", id,brSlojevaFarbe[id], povrsina[id], vreme[id]);

		//pthread_mutex_lock(&mutexFarbanje);
		if(brSlojevaFarbe[id]>0){ //idem opat da probam da ofarbam
			//kada ceka
			pthread_mutex_lock(&mutexFarbanje);
			while(zauzetostFarbare>=brRadnika /*|| brSlojevaFarbe[id]>0*/)
				pthread_cond_wait(&condFarbanje, &mutexFarbanje);
			
			//mogu u farbaru
			zauzetostFarbare++;
			brSlojevaFarbe[id]--;
			pthread_mutex_unlock(&mutexFarbanje);

			printf("na deo %ld se nanosi sloj farbe\n", id);
			sleep(rand()%povrsina[id]);

			pthread_mutex_lock(&mutexFarbanje);
			zauzetostFarbare--;
		//	if(zauzetostFarbare<2) //kada izadjem moze sledeci na farbanje
				pthread_cond_broadcast(&condFarbanje); //
			pthread_mutex_unlock(&mutexFarbanje);

			printf("deo %ld je zavrsio sa farbanjem\n", id);

			pthread_mutex_lock(&mutexFarbanje);
			//ide susenje
			pthread_cond_broadcast(&condSusenje);
			pthread_mutex_unlock(&mutexFarbanje);
		}
		else{
		//	pthread_mutex_unlock(&mutexFarbanje);
			pthread_exit(NULL);
		}
}

void *susenje(void *arg)
{
	long id=(long)arg;
		
		pthread_mutex_lock(&mutexSusenje);
		while(zauzetostSusare>=kapacitetSusare)
			pthread_cond_wait(&condSusenje, &mutexSusenje);

		//kada radim
		zauzetostSusare++;
		pthread_mutex_unlock(&mutexSusenje);

		printf("deo %ld se susi\n", id);
		sleep(rand()%s);

		pthread_mutex_lock(&mutexSusenje);
		//zavrsio susenje
		zauzetostSusare--;
		//pthread_cond_broadcast(&condSusenje); //
		pthread_mutex_unlock(&mutexSusenje);

		printf("deo %ld je zavrsio sa susenjem\n", id);

		pthread_mutex_lock(&mutexSusenje);
		//ide farbanje
		pthread_cond_broadcast(&condSusenje); //
		pthread_cond_broadcast(&condFarbanje);
		pthread_mutex_unlock(&mutexSusenje);

}

int main()
{
	for(int i=0;i<brDelova;i++){
		vreme[i]=0;
		povrsina[i]=0;
		brSlojevaFarbe[i]=0;
	}

	pthread_t t[brDelova+brRadnika];

	pthread_mutex_init(&mutexFarbanje, NULL);
	pthread_mutex_init(&mutexSusenje, NULL);
	pthread_cond_init(&condFarbanje, NULL);	
	pthread_cond_init(&condSusenje, NULL);	

	for(long i=0;i<brRadnika;i++)
		pthread_create(t+i, NULL, farbanje, (void*)i);

	for(long i=0;i<brDelova;i++)
		pthread_create(t+brDelova+i, NULL, susenje, (void*)i);

	for(int i=0;i<brDelova+brRadnika;i++)
		pthread_join(t[i], NULL);

	return 0;
}



