#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>

#define BROJ_DELOVA 40
#define BROJ_MESTA_U_SUSARI 5
#define SUSENJE_VREME 2

pthread_mutex_t mutexF;
pthread_cond_t condF;
pthread_mutex_t mutexS;
pthread_cond_t condS;

int uSusari = 0;
int farbanje = 0;


void * work(void * arg)
{
    long id = (long)arg;
    int p = 1+rand()%5;
    int k = 1+rand()%5;

    sleep(rand()%20);
    printf("Deo %ld povrsine %d dolazi na farbanje %d sloja.\n",id,p,k);

    for(int i=0;i<k;i++)
    {
        pthread_mutex_lock(&mutexF);
        while(farbanje > 1)
            pthread_cond_wait(&condF,&mutexF);
        
        farbanje++;
        printf("Deo %ld zapocinje farbanje %d od %d sloja.\n",id,(i+1),k);
        pthread_mutex_unlock(&mutexF);

        sleep(p);
        
        pthread_mutex_lock(&mutexF);
        farbanje--;
        printf("Deo %ld zavrsio farbanje %d od %d sloja.\n",id,(i+1),k);
        pthread_cond_broadcast(&condF);
        pthread_mutex_unlock(&mutexF);

        pthread_mutex_lock(&mutexS);
        while(uSusari==BROJ_MESTA_U_SUSARI)
            pthread_cond_wait(&condS,&mutexS);

        uSusari++;
        printf("Deo %ld zapocinje susenje %d od %d sloja.\n",id,(i+1),k);
        pthread_mutex_unlock(&mutexS);

        sleep(SUSENJE_VREME);

        pthread_mutex_lock(&mutexS);
        uSusari--;
        printf("Deo %ld zavrsio susenje %d od %d sloja.\n",id,(i+1),k);
        pthread_cond_broadcast(&condS);
        pthread_mutex_unlock(&mutexS);
    }
    printf("Deo %ld je gotov.\n",id);
}


int main(){
    pthread_t delovi[BROJ_DELOVA];

    pthread_mutex_init(&mutexF,NULL);
    pthread_cond_init(&condF,NULL);
    pthread_mutex_init(&mutexS,NULL);
    pthread_cond_init(&condS,NULL);

    for (long i=0;i<BROJ_DELOVA;i++)
    {
        pthread_create(delovi+i,NULL,work,(void *)i);
    }

    for (int i=0;i<BROJ_DELOVA;i++)
    {
        pthread_join(delovi[i],NULL);
    }

    pthread_cond_destroy(&condF);
    pthread_mutex_destroy(&mutexF);
    pthread_cond_destroy(&condS);
    pthread_mutex_destroy(&mutexS);

    return 0;
}