
// NAPOMENA: printf - treba sto manje koristiti u kriticnom regionu, ali je napisan radi lakseg testiranja koda

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

// #define brojDelova 10

int s = 1; // broj sekundi za susenje
// int p[10] = {1,2,1,2,1,2,1,2,1,1}; // povrsina svakog dela posebno (a toliko i sekundi za jedno farbanje) - pa nakon ovoga ide u susaru na s sekundi
// int k[10] = {2,1,2,1,2,1,2,2,1,1}; // slojeva farbe 
int x = 3; // mogucnost susenja tri dela odjednom
int brojRadnika = 2;

#define brojDelova 20
int p[brojDelova] = {1,2,2,1,2,1,2,2,1,1,1,1,1,1,2,2,1,1,1,2};
int k[brojDelova] = {2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};

pthread_mutex_t mutexRadnik, mutexSusara;
pthread_cond_t condRadnik, condSusara;

void *farbaj(void *arg)
{
	long idDela = (long) arg;
	
	for ( int i = 0; i < k[idDela]; i ++ ) // k puta se farba (k slojeva)
	{
		printf("Deo %ld: Dosao sam na farbanje.   (majstor me jos nije uzeo)\n", idDela);
		pthread_mutex_lock(&mutexRadnik);
		while ( brojRadnika < 1 ) pthread_cond_wait(&condRadnik, &mutexRadnik); // ukoliko su oba radnika zauzeta cekaj da neki od radnika javi kada zavrsi farbanje
		
		brojRadnika --;
		printf("BROJ RADNIKA %d\nDeo %ld: Radnik me je uzeo. Farbanje u toku..\n", brojRadnika, idDela);
		//printf("Deo %ld: Radnik me je uzeo. Farbanje u toku..\n", idDela);
		sleep(p[idDela]);
		brojRadnika ++;
		printf("BROJ RADNIKA %d\n", brojRadnika);
		pthread_cond_broadcast(&condRadnik);
		
		pthread_mutex_unlock(&mutexRadnik);
		printf("Deo %ld: Ofarbano, otkljucan mutexRadnik\nDeo %ld: Proveravam da li ima mesta u susari..\n", idDela, idDela);
		
		//printf("Deo %ld: Proveravam da li ima mesta u susari..\n", idDela);	
		pthread_mutex_lock(&mutexSusara);
		while ( x < 1 ) pthread_cond_wait(&condSusara, &mutexSusara);
		
		x --; // smanji broj slobodnih mesta u susari kada deo udje u susaru
		printf("BROJ MESTA U SUSARI %d\nDeo %ld: Usao sam u susaru. Susenje..\n", x, idDela);
		//printf("Deo %ld: Usao sam u susaru. Susenje..\n", idDela);
		sleep(s);
		x ++; // povecaj broj slobodnih mesta u susari kada deo izadje iz susare
		printf("BROJ MESTA U SUSARI %d\n", x);
		pthread_cond_broadcast(&condSusara);
		printf("Deo %ld: Javljam svima da sam osusen.\n", idDela);
		pthread_mutex_unlock(&mutexSusara);
		printf("Deo %ld: Izlazim iz susare i otkljucavam mutexSusara\n", idDela);
	}
	printf("Gotovo\n");
}

int main(int argc, char **argv)
{
	pthread_t threads[brojDelova];
	pthread_mutex_init(&mutexRadnik, NULL);
	pthread_cond_init(&condRadnik, NULL);
	pthread_mutex_init(&mutexSusara, NULL);
	pthread_cond_init(&condSusara, NULL);
	
	for ( long i = 0; i < brojDelova; i ++ )
		pthread_create(&threads[i], NULL, farbaj, (void*)i);
		
	for ( long i = 0; i < brojDelova; i ++ )
		pthread_join(threads[i], NULL);
	
	return 0;
}


