#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <time.h>
#include <unistd.h>

#define BROJ_DELOVA 10
#define SUSARA_MAX 3
#define VREME_SUSENJA 2
#define VREME_NANOSENJA_FARBE 3
#define SLOBODAN_RADNIK 1
#define ZAUZET_RADNIK 0
#define POVRSNIA 5
#define SLOJEVI 5

pthread_mutex_t mutex;
pthread_cond_t condSusara;
pthread_cond_t condRadnik;

int susara = 0;
int radnik1[2] = {1, SLOBODAN_RADNIK};
int radnik2[2] = {2, SLOBODAN_RADNIK};

void *deo(void *arg) {
    // u odnosu na id se gleda vreme i ostalo
    long id = (long) arg;
    int dolazak = (int) id;
    sleep(dolazak);

    int povrsnia = (rand() % POVRSNIA) + 1;
    int slojevi = (rand() % SLOJEVI) + 1;
    int vreme_nanosenja_farbe = (rand() % VREME_NANOSENJA_FARBE) + 1;
    int ofarbano_slojeva = 0;
    int moj_radnik = 0;

    printf("Na %ld deo treba se naneti %d slojeva.\n", id, slojevi);
    while (ofarbano_slojeva < slojevi) {
        pthread_mutex_lock(&mutex);
        while(radnik1[1] == ZAUZET_RADNIK && radnik2[1] == ZAUZET_RADNIK)
            pthread_cond_wait(&condRadnik, &mutex);

        if (radnik1[1] == SLOBODAN_RADNIK) {
            radnik1[1] = ZAUZET_RADNIK;
            moj_radnik = radnik1[0];
        }
        else if (radnik2[1] == SLOBODAN_RADNIK) {
            radnik2[1] = ZAUZET_RADNIK;
            moj_radnik = radnik2[0];
        }
        ofarbano_slojeva++;
        printf("Radnik %d nanosi sloj %ld. dela. Ofarbano slojeva %d.\n", moj_radnik, id, ofarbano_slojeva);
        pthread_mutex_unlock(&mutex);

        sleep(vreme_nanosenja_farbe);

        pthread_mutex_lock(&mutex);
        // printf("Radnik %d proba da stavi u susaru %ld deo.\n", moj_radnik, id);
        while (susara >= SUSARA_MAX)
            pthread_cond_wait(&condSusara, &mutex);

        susara++;
        printf("Radnik %d nosi deo %ld na susenje. Ofarbano slojeva %d. Stanje u susari %d.\n", moj_radnik, id, ofarbano_slojeva, susara);
        pthread_mutex_unlock(&mutex);

        sleep(VREME_SUSENJA);

        pthread_mutex_lock(&mutex);
        printf("Deo %ld je osusen, spreman je za nanosenje sledeceg sloja.\n", id);
        radnik1[1] = SLOBODAN_RADNIK;
        radnik2[1] = SLOBODAN_RADNIK;
        susara--;
        pthread_cond_broadcast(&condRadnik);
        pthread_cond_broadcast(&condSusara);
        printf("Radnik %d je zavrsio farbanje i susenje jednog sloja %ld. dela. Stanje u susari %d.\n", moj_radnik, id, susara);
        pthread_mutex_unlock(&mutex);
    }

    pthread_exit(NULL);
}

int main() {
    srand(time(NULL));
    pthread_t threads[BROJ_DELOVA];
    pthread_mutex_init(&mutex, NULL);
    pthread_cond_init(&condRadnik, NULL);
    pthread_cond_init(&condSusara, NULL);

    for (long i = 0; i < BROJ_DELOVA; i++)
        pthread_create(&threads[i], NULL, deo, (void *)i);

    for (long i = 0; i < BROJ_DELOVA; i++)
        pthread_join(threads[i], NULL);

    pthread_mutex_destroy(&mutex);
    pthread_cond_destroy(&condRadnik);
    pthread_cond_destroy(&condSusara);

    pthread_exit(NULL);
    return 0;
}