#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include <time.h>

#define N 30

void *susenje(void *arg);
void *farbanje(void *arg);

pthread_mutex_t mutexSusara, mutexFarbara;
pthread_cond_t condSusara, condFarbara;

int susara = 5;
int farbara = 2;

int redZaSusenje[N];
int redZaFarbanje[N];
int brojSlojeva[N];
int povrsina[N];
int vremeSusenja[N];
int stanje[N];

void *farbanje(void *arg){
    long id = (long)arg;

    if(povrsina[id] == 0){
        sleep(rand()%3);
        povrsina[id] = rand()%5 + 1;
        brojSlojeva[id] = rand()%3 + 1;
    }

    if(brojSlojeva[id] == 0)
        pthread_exit(NULL);

    printf("Deo %ld stize na farbanje\n", id);

    pthread_mutex_lock(&mutexFarbara);

    while(farbara == 0 || stanje[id] != 0)
        pthread_cond_wait(&condFarbara, &mutexFarbara);
    farbara--;
    pthread_mutex_unlock(&mutexFarbara);  

    printf("Deo %ld se farba %d sekundi i ima %d sloja\n", id, povrsina[id], brojSlojeva[id]);
    sleep(povrsina[id]);
    printf("Deo %ld je ofarban\n", id);

    brojSlojeva[id]--;
    stanje[id] = 1;

    pthread_mutex_lock(&mutexFarbara);
    farbara++;
    pthread_cond_broadcast(&condSusara);
    pthread_cond_broadcast(&condFarbara);
    pthread_mutex_unlock(&mutexFarbara);
}

void *susenje(void *arg){
    long id = (long)arg;

    if(vremeSusenja[id] == 0){
        vremeSusenja[id] = rand()%5 + 1;
    }

    if(brojSlojeva[id] == 0)
        pthread_exit(NULL);


    pthread_mutex_lock(&mutexSusara);

    while(susara == 0 || stanje[id] == 0)
        pthread_cond_wait(&condSusara, &mutexSusara);

    susara--;
    pthread_mutex_unlock(&mutexSusara);

    printf("Deo %ld stize na susenje\n", id);
    printf("Deo %ld se susi %d sekundi\n", id, vremeSusenja[id]);
    if(susara == 0)
        printf("Susara je trenutno puna\n");
    sleep(vremeSusenja[id]);
    printf("Deo %ld je osusen\n", id);

    stanje[id] = 0;

    pthread_mutex_lock(&mutexSusara);
    susara++;
    pthread_cond_broadcast(&condFarbara);
    pthread_cond_broadcast(&condSusara);
    pthread_mutex_unlock(&mutexSusara);

}

int main()
{
    pthread_mutex_init(&mutexSusara, NULL);
    pthread_mutex_init(&mutexFarbara, NULL);
    pthread_cond_init(&condSusara, NULL);
    pthread_cond_init(&condFarbara, NULL);

    pthread_t t[N];
    pthread_t s[N];

    for(int i = 0 ; i < N; i ++){
        povrsina[i] = 0;
        brojSlojeva[ i ] = 0;
        vremeSusenja[i] = 0;
        stanje[i] = 0;
    }

    for(long i = 0 ; i < N ; i ++){
        pthread_create(t+i,NULL, farbanje, (void*)i);
        pthread_create(s+i,NULL, susenje, (void*)i);
    }

    for(int i = 0 ; i < N ; i ++){
        pthread_join(t[i], NULL);
        pthread_join(s[i], NULL);
    }

    pthread_mutex_destroy(&mutexFarbara);
    pthread_mutex_destroy(&mutexSusara);
    pthread_cond_destroy(&condFarbara);
    pthread_cond_destroy(&condSusara);

    return 0;
}