#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <stdlib.h>

pthread_mutex_t mutexFarbanje = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t condFarbanje = PTHREAD_COND_INITIALIZER;

pthread_mutex_t mutexSusenje = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t condSusenje = PTHREAD_COND_INITIALIZER;

#define VREME_SUSENJA 3
#define MAX_BROJ_DELOVA_U_SUSARI 3
#define BROJ_RADNIKA_KOJI_FARBAJU 2

typedef struct {
    int id;
    int p;
    int k;
    int t;
} Deo;

int brojDelovaZaFarbanje = 0;
int brojDelovaZaSusenje = 0;

#define BROJ_DELOVA 10

Deo *delovi;

void *deoNit(void *idx) {
    int id = (int) idx;
    Deo deo = delovi[id];
    
    //printf("%d %d %d %d\n", deo.id, deo.p, deo.k, deo.t);

    sleep(deo.t);

    for (int i = 0; i < deo.k; i++) {
        printf("Deo %d ceka farbanje za %d sloj\n", deo.id, i +1);

        pthread_mutex_lock(&mutexFarbanje);

        while(brojDelovaZaFarbanje == BROJ_RADNIKA_KOJI_FARBAJU)
            pthread_cond_wait(&condFarbanje, &mutexFarbanje);
        brojDelovaZaFarbanje++;

        pthread_mutex_unlock(&mutexFarbanje);

        printf("Farbam deo %d, sloj %d\n", deo.id, i+1);
        sleep(deo.p);
        printf("Zavrsio sam farbanje dela %d, sloj %d\n", deo.id, i+1);

        pthread_mutex_lock(&mutexFarbanje);

        brojDelovaZaFarbanje--;
        pthread_cond_broadcast(&condFarbanje);

        pthread_mutex_unlock(&mutexFarbanje);

        printf("Deo je izasao iz farbare %d, sloj %d\n", deo.id, i+1);

        printf("Deo %d ceka susenje sloja %d\n", deo.id, i+1);

        pthread_mutex_lock(&mutexSusenje);

        while(brojDelovaZaSusenje == MAX_BROJ_DELOVA_U_SUSARI)
            pthread_cond_wait(&condSusenje, &mutexSusenje);
        brojDelovaZaSusenje++;

        pthread_mutex_unlock(&mutexSusenje);

        printf("Susim deo %d, sloj %d\n", deo.id, i+1);
        sleep(VREME_SUSENJA);
        printf("Zavrsio sam susenje dela %d, sloj %d\n", deo.id, i+1);

        pthread_mutex_lock(&mutexSusenje);

        brojDelovaZaSusenje--;
        pthread_cond_broadcast(&condSusenje);

        pthread_mutex_unlock(&mutexSusenje);

        printf("Deo je %d izasao iz susare, sloj %d\n", deo.id, i+1);
    }

    pthread_exit(NULL);
}

int main() {
    pthread_t niti[BROJ_DELOVA];

    int povrsine[BROJ_DELOVA] = {5, 3, 6, 7, 10, 2, 1, 9, 4, 10};
    int brojSlojeva[BROJ_DELOVA] = {2, 1, 3, 3, 2, 2, 1, 4, 5, 3};
    int vremeDolaska[BROJ_DELOVA] = {2, 1, 3, 3, 2, 2, 1, 4, 5, 3};
    delovi = (Deo*) malloc(BROJ_DELOVA * sizeof(Deo));

    for (int i = 0; i < BROJ_DELOVA; i++) {
        delovi[i].id = i;
        delovi[i].k = brojSlojeva[i];
        delovi[i].p = povrsine[i];
        delovi[i].t = vremeDolaska[i];
        pthread_create(&niti[i], NULL, deoNit, (void *) i);
    }

    pthread_exit(NULL);

    return 0;
}