#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>

pthread_mutex_t mutex1;
pthread_mutex_t mutex2;
pthread_mutex_t mutex;
pthread_cond_t cond1;
pthread_cond_t cond2;

#define BROJ_DELOVA 10
#define s 4
#define X 5

int deoFarba = 0;//broj delova koji su u susari
int radnik1 = 0;//radnik1 farba deo,0-nije zauzet,1 jeste zauzet
int radnik2 = 0;//radnik2 farba deo, 0-nije zauzet,1 jeste zauzet
int susara = 0;


void *farbanje(void *t)
{
    long i = (long)t;
    //int deoSeFarba = 0;//0-ne farba se,1 farba se

    int stime = rand()%15 + 1;
    int p = rand() % 10 + 1;
    int k = rand() % 3 + 1;
    int kProslo = k;//koliko je slojeva ofarbano
    int ofarbanSloj = 0;

    sleep(stime);

    printf("Deo %ld je stigao na farbanje posle %ds i zahteva %d sloj/a.\n",i,stime,k);

    while(kProslo > 0)
    {
        //deoSeFarba = 0;
        pthread_mutex_lock(&mutex);

        while(radnik1==1 && radnik2==1)
            pthread_cond_wait(&cond1,&mutex);
        pthread_mutex_unlock(&mutex);

        if(radnik1==0)
        {
            pthread_mutex_lock(&mutex1);
            //deoSeFarba = 1;
            radnik1 = 1;
            printf("Radnik1 farba %ld. deo.\n",i);
            sleep(p);
            radnik1=0;
            pthread_cond_broadcast(&cond1);
            pthread_mutex_unlock(&mutex1);
        }
        else if(radnik2==0)
        {
            pthread_mutex_lock(&mutex2);
            //deoSeFarba = 1;
            radnik2 = 1;
            printf("Radnik2 farba %ld. deo.\n",i);
            sleep(p);
            radnik2 = 0;
            pthread_cond_broadcast(&cond1);
            pthread_mutex_unlock(&mutex2);
        }
    
        //pthread_mutex_unlock(&mutex);
        ofarbanSloj++;

        printf("Delu %ld je ofarban sloj %d.\n",i,ofarbanSloj);
        printf("Deo %ld ceka da udje u susaru.\n",i);

        pthread_mutex_lock(&mutex);

        while(susara >= X)
            pthread_cond_wait(&cond2,&mutex);
        
        susara++;
        pthread_mutex_unlock(&mutex);

        printf("Deo %ld je usao u susaru.\n",i);
        sleep(s);

        pthread_mutex_lock(&mutex);
        susara--;
        pthread_cond_broadcast(&cond2);
        pthread_mutex_unlock(&mutex);

        printf("Deo %ld izlazi iz susare.\n",i);

        kProslo--;
    }

    printf("Deo %ld je ofarban skroz.\n",i);


    pthread_exit(NULL);

}

int main()
{
    pthread_t delovi[BROJ_DELOVA];
    long i;
    srand(time(NULL));
    pthread_mutex_init(&mutex,NULL);
    pthread_mutex_init(&mutex1,NULL);
    pthread_mutex_init(&mutex2,NULL);
    pthread_cond_init(&cond1,NULL);    
    pthread_cond_init(&cond2,NULL);


    for(i = 0;i < BROJ_DELOVA;i++)
    {
        pthread_create(&delovi[i],NULL,farbanje,(void*)i);
    }

    for(i = 0;i < BROJ_DELOVA;i++)
    {
        pthread_join(delovi[i],NULL);
    }

}