#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <unistd.h>

#define i 10 // broj delova
#define x 3 // maks broj u susari
#define s 2 // broj sekundi za susenje

int p[i] = {4,3,1,4,3,2,5,2,4,3}; // povrsina
int k[i] = {1,3,4,3,2,1,2,3,4,2}; // koliko slojeva imaju
int t[i] = {1,4,5,3,2,6,5,4,3,8}; // vreme za koje stize deo

pthread_mutex_t mutexSusara = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t mutexFarbara = PTHREAD_MUTEX_INITIALIZER;

pthread_cond_t condFarbara = PTHREAD_COND_INITIALIZER;
pthread_cond_t condSusara = PTHREAD_COND_INITIALIZER;

int brojDelovaUSusari = 0; // deljeni resurs
int radnik[2] = {0,0}; // 0-ne radi, 1-radi

void *farbanje(void *arg)
{
    long id = (long)arg;
    int pom = -1;
    
    sleep(t[id]);
    printf("DEO %ld, stize na farbanje posle: %d sekunde.\n",id,t[id]);

    while(1)
    {
        if(k[id] == 0)
        {
            break;
        }

        pthread_mutex_lock(&mutexFarbara);
        while(radnik[0]==1 || radnik[1]==1)
        {
            pthread_cond_wait(&condFarbara,&mutexFarbara);
        }

        if(radnik[0]==0)
        {
            radnik[0] = 1;
            k[id]--;
            pom = 0; // oznava mi kod kojeg je radnika bio deo
        }
        else
        {
            radnik[1] = 1;
            k[id]--;
            pom = 1;
        }
        pthread_mutex_unlock(&mutexFarbara);


        sleep(p[id]);
        printf("DEO %ld,je OFARBAN jednom\n",id);

        pthread_mutex_lock(&mutexFarbara);
        radnik[pom] = 0;
        pthread_cond_broadcast(&condFarbara);
        pthread_mutex_unlock(&mutexFarbara);

        pthread_mutex_lock(&mutexSusara);
        while(brojDelovaUSusari > x)
        {
            pthread_cond_wait(&condSusara,&mutexSusara);
        }
        brojDelovaUSusari++;
        pthread_mutex_unlock(&mutexSusara);

        sleep(s);
        printf("DEO %ld,je OSUSEN jednom\n",id);
        
        pthread_mutex_lock(&mutexSusara);
        brojDelovaUSusari--;
        pthread_cond_broadcast(&condSusara);
        pthread_mutex_unlock(&mutexSusara);
    }

    pthread_exit(NULL);
}

int main()
{
    pthread_t delovi[i];

    for(long k=0;k<i;k++)
    {
        pthread_create(delovi + k, NULL, farbanje,(void *)k);
    }

    pthread_exit(NULL);
    return 0;
}