#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>

#define BROJ_DELOVA 10
#define KAPACITET_SUSARE 3
#define MAX_BROJ_SLOJEVA 5
#define MAX_POVRSINA 10
#define VREME_SUSENJA 12
#define FARBANJE 0
#define SUSARA 1

// mutex[0] za dolazak na farbanje
// mutex[1] za dolazak na susenje
pthread_mutex_t mutexi[2];
pthread_cond_t cond;

int ukupnoUSusari = 0;

void *farbanjeISusenje(void *t)
{
    long i = (long)t;
    sleep(i); 
    printf("Deo %ld je stigao.\n",i);
    // ukoliko je potrebno postaviti random broj slojeva:
    // int k = (rand()%MAX_BROJ_SLOJEVA)+1
    // ukoliko je potrebno postaviti povrsinu u odnosu na indetifikator i:
    // int povrsina = i+1
    int povrsina = (rand()%MAX_POVRSINA)+1;
    int k = i+1;

    while(k != 0)
    {
        // farbanje
        pthread_mutex_lock(&mutexi[FARBANJE]);

        printf("Farbanje %ld dela...\n",i);
        sleep(povrsina);
        k--;

        pthread_mutex_unlock(&mutexi[FARBANJE]);

        printf("Farbanje %ld dela je gotovo.\n",i);

        //susenje
        pthread_mutex_lock(&mutexi[SUSARA]);

        while(ukupnoUSusari >= KAPACITET_SUSARE)
        {
            pthread_cond_wait(&cond, &mutexi[SUSARA]);
        }
        ukupnoUSusari++;

        pthread_mutex_unlock(&mutexi[SUSARA]);

        printf("Susenje dela %ld...\n", i);
        sleep(VREME_SUSENJA);

        pthread_mutex_lock(&mutexi[SUSARA]);
        ukupnoUSusari--;
        pthread_cond_broadcast(&cond);

        pthread_mutex_unlock(&mutexi[SUSARA]);
        if(k!=0)
        {
            printf("Susenje dela %ld je gotovo. Broj preostalih slojeva - %d.\n", i,k);
        }
        else{
            printf("Susenje i farbanje dela %ld  je skroz zavrseno.\n", i);
        }
    }
}

int main(int *argc, char **argv)
{
    long i;
    srand(time(NULL));
    pthread_t niti[BROJ_DELOVA];
    pthread_attr_t attr;

    pthread_mutex_init(&mutexi[0],NULL);
    pthread_mutex_init(&mutexi[1],NULL);
    pthread_cond_init(&cond,NULL);
    pthread_attr_init(&attr);
    pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_JOINABLE);

    for(i=0;i<BROJ_DELOVA;i++)
    {
        pthread_create(&niti[i], &attr, farbanjeISusenje, (void *)i);
    }
    for(i=0;i<BROJ_DELOVA;i++)
    {
        pthread_join(niti[i], NULL);
    }

    pthread_mutex_destroy(&mutexi[0]);
    pthread_mutex_destroy(&mutexi[1]);
    pthread_cond_destroy(&cond);
    pthread_attr_destroy(&attr);
    pthread_exit(NULL);

    return 0;
}