#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <time.h>
#include <unistd.h>


#define X 5 //maksimalni broj delova u susari u jednom momentu
#define S 3
#define BROJ_DELOVA_R1 20 //broj delova za radnika 1
#define BROJ_DELOVA_R2 20 //broj delova za radnika 2

int brojDelovaUSusari = 0;

pthread_mutex_t mutexRadnik1, mutexRadnik2, mutexSusara;
pthread_cond_t condSusara;

int delovi_ti[BROJ_DELOVA_R1 + BROJ_DELOVA_R2];
int delovi_pi[BROJ_DELOVA_R1 + BROJ_DELOVA_R2];
int delovi_ki[BROJ_DELOVA_R1 + BROJ_DELOVA_R2];

void *farbanjeRadnik1(void *t)
{
	long tId = (long)t;
	sleep(delovi_ti[tId]);
	printf("Deo %ld stize u farbaru za radnika 1 posle vremena %d\n", tId, delovi_ti[tId]);

	while(delovi_ki[tId] > 0)
	{
		pthread_mutex_lock(&mutexRadnik1);
		sleep(delovi_pi[tId]);
		printf("Deo %ld farba prvi radnik za vreme: %d\n", tId, delovi_ti[tId]);
		delovi_ki[tId]--; //zato sto mora Ki puta da se ofarba
		pthread_mutex_unlock(&mutexRadnik1);


		pthread_mutex_lock(&mutexSusara);

		while(brojDelovaUSusari == X)
			pthread_cond_wait(&condSusara, &mutexSusara);
		brojDelovaUSusari++;
		sleep(S); //vreme susenja u susari
		printf("Deo %ld se susi %d sekundi. Trenutan broj u susari: %d\n", tId, S, brojDelovaUSusari);
		brojDelovaUSusari--;
		pthread_cond_broadcast(&condSusara);
		pthread_mutex_unlock(&mutexSusara);
	}



	pthread_exit(NULL);
}

void *farbanjeRadnik2(void *t)
{
	long tId = (long)t;
	sleep(delovi_ti[tId]);
	printf("Deo %ld stize u farbaru za radnika 2 posle vremena %d\n", tId, delovi_ti[tId]);

	while(delovi_ki[tId] > 0)
	{
		pthread_mutex_lock(&mutexRadnik2);
		sleep(delovi_pi[tId]);
		printf("Deo %ld farba drugi radnik za vreme: %d\n", tId, delovi_ti[tId]);
		delovi_ki[tId]--; //zato sto mora Ki puta da se ofarba
		pthread_mutex_unlock(&mutexRadnik2);


		pthread_mutex_lock(&mutexSusara);

		if(brojDelovaUSusari == X)
			pthread_cond_wait(&condSusara, &mutexSusara);
		brojDelovaUSusari++;
		sleep(S); //vreme susenja u susari
		printf("Deo %ld se susi %d sekundi. Trenutan broj u susari: %d\n", tId, S, brojDelovaUSusari);
		brojDelovaUSusari--;
		pthread_cond_broadcast(&condSusara);
		pthread_mutex_unlock(&mutexSusara);
	}



	pthread_exit(NULL);
}

int main()
{
	pthread_t threads[BROJ_DELOVA_R1 + BROJ_DELOVA_R2];
	pthread_mutex_init(&mutexRadnik1, NULL);
	pthread_mutex_init(&mutexRadnik2, NULL);
	pthread_cond_init(&condSusara, NULL);

	long t;
	srand(time(NULL));

	//radnik1
	for (int i = 0; i < BROJ_DELOVA_R1; ++i)
	{
		delovi_ti[i] = rand() % 3 + 1;
		delovi_pi[i] = rand() % 3 + 1;
		delovi_ki[i] = rand() % 3 + 1;
	}

	//radnik2
	for (int i = BROJ_DELOVA_R1; i < BROJ_DELOVA_R1 + BROJ_DELOVA_R2; ++i)
	{
		delovi_ti[i] = rand() % 3 + 1;
		delovi_pi[i] = rand() % 3 + 1;
		delovi_ki[i] = rand() % 3 + 1;
	}

	//radnik1
	for (t = 0; t < BROJ_DELOVA_R1; ++t)
	{
		pthread_create(&threads[t], NULL, farbanjeRadnik1, (void*)t);
	}

	//radnik2
	for (t = BROJ_DELOVA_R1; t < BROJ_DELOVA_R1 + BROJ_DELOVA_R2; ++t)
	{
		pthread_create(&threads[t], NULL, farbanjeRadnik2, (void*)t);
	}


	pthread_exit(NULL);
}