#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include <time.h>

#define X 3 // max broj delova za susenje
#define S 5 // broj sekundi preodredjen za susenje
#define broj_delova 15 // broj delova koji treba da se ofarba
#define max_majstora 2 // najvise 2 majstora posotje

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cond = PTHREAD_COND_INITIALIZER;
int broj_majstora = 0;
int broj_u_susari = 0;

void* farbanje(void *i){
    long id = (long) i;
    long pi = id, ti = id; // pi sekundi je potrebno da se ofarba, a ti je vreme kada stize deo
    long ki = rand() % 4 + 1; // ki predstavlja koliko puta se farba jedan deo (od 1 do 4)
    long brojac_slojeva = 0; // pomocna pormenljiva koja ce mi brojati slojeve

    sleep(ti); // Deo dolazi u trenutku ti

    while(ki > brojac_slojeva){ // predmet se vraca na farbanje dok se ne zavrse svi slojevi

        pthread_mutex_lock(&mutex);

        printf("Deo stize u ti trenutku u farbaru %ld \n", ti);

        while(max_majstora == broj_majstora) // posto postoje 2 majstora
            pthread_cond_wait(&cond, &mutex);
        
        broj_majstora++;

        brojac_slojeva++;
        
        sleep(pi); // Farbanje dela

        printf("Majstor je ofarbao deo %ld. \n", id);

        broj_majstora--;

        pthread_mutex_unlock(&mutex);

        printf("Deo %ld je ofarban %ld puta, a potrebno je %ld. \n", id, brojac_slojeva, ki);

        pthread_mutex_lock(&mutex);

        while(broj_u_susari == X) // proverava se max delova u susari
            pthread_cond_wait(&cond, &mutex);

        broj_u_susari++;

        pthread_mutex_unlock(&mutex);

        sleep(S); // Vreme susenja dela

        printf("Deo %ld se osusio. \n", id);

        pthread_mutex_lock(&mutex);

        broj_u_susari--;

        pthread_mutex_unlock(&mutex);

        pthread_mutex_lock(&mutex);

        if(id == 0)
            pthread_cond_broadcast(&cond);

        pthread_mutex_unlock(&mutex);
    }

    printf("Deo %d je zavrsio sa farbanjem. \n", id);
}

int main(){

    srand(time(NULL));

    pthread_t threads[broj_delova];
    long i;

    for (i = 1; i <= broj_delova; i++){
        pthread_create(&threads[i], NULL, farbanje, (void*)i);
    }

    for (i = 1; i <= broj_delova; i++){
        pthread_join(threads[i], NULL);
    }

    pthread_exit(NULL);

    return 0;
}