#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<pthread.h>

#define BROJ_RADNIKA 2
#define BROJ_MESTA_U_SUSARI 5
#define BROJ_DELOVA 20
#define MAX_POVRSINA 10
#define MAX_SLOJEVA 10

int farbari = 0, mesta_u_susari = 0;

pthread_mutex_t farbanje = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t susara = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cond_farbanje = PTHREAD_COND_INITIALIZER;
pthread_cond_t cond_susara = PTHREAD_COND_INITIALIZER;

void *farbaj(void *arg){
    long tid = (long)arg;
    int t = rand() % BROJ_DELOVA + 1;
    sleep(t);
    printf("Deo %ld je dosao u farbaru nakon %d sekundi\n", tid, t);

    int povrsina = rand() % MAX_POVRSINA + 1;
    int broj_slojeva = rand() % MAX_SLOJEVA + 1; 
    int i = 1;
    while(i <= broj_slojeva){
        pthread_mutex_lock(&farbanje);
        while(farbari >= BROJ_RADNIKA){
            pthread_cond_wait(&cond_farbanje, &farbanje);
        }
        farbari++;
        pthread_mutex_unlock(&farbanje);

        sleep(povrsina);
        printf("Deo %ld je ofarban u sloj %d.\n", tid, i);
        
        pthread_mutex_lock(&farbanje);
        farbari--;
        pthread_cond_broadcast(&cond_farbanje);
        pthread_mutex_unlock(&farbanje);

        // susara
        printf("Deo %ld je stigao ispred susare\n", tid);
        pthread_mutex_lock(&susara);
        while(mesta_u_susari >= BROJ_MESTA_U_SUSARI){
            pthread_cond_wait(&cond_susara, &susara);
        }
        mesta_u_susari++;
        pthread_mutex_unlock(&susara);
        
        sleep(1);
        printf("Deo %ld se susi u susari\n", tid);

        pthread_mutex_lock(&susara);
        mesta_u_susari--;
        pthread_cond_broadcast(&cond_susara);
        pthread_mutex_unlock(&susara);

        printf("Sloj %d dela %ld je osusen.\n",i,tid);
        i++;
    }

    printf("Deo %ld je ofarban u celosti\n", tid);
    pthread_exit(NULL); 
}

int main(){
    pthread_t delovi[BROJ_DELOVA];
    pthread_mutex_init(&farbanje, NULL);
    pthread_mutex_init(&susara, NULL);
    pthread_cond_init(&cond_farbanje, NULL);
    pthread_cond_init(&cond_susara, NULL);
    for(long i = 0; i < BROJ_DELOVA; i++){
        pthread_create(delovi + i, NULL, farbaj, (void*)i);
    }
    for(long i = 0; i < BROJ_DELOVA; i++){
        pthread_join(delovi[i], NULL);
    }
    pthread_mutex_destroy(&farbanje);
    pthread_mutex_destroy(&susara);
    pthread_cond_destroy(&cond_farbanje);
    pthread_cond_destroy(&cond_susara);
    return 0;
}