#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>

#define P 20
#define X 10
#define S 5
#define RADNICI 2

pthread_mutex_t mutex= PTHREAD_MUTEX_INITIALIZER;
//pthread_mutex_t mutex_susenje = PTHREAD_MUTEX_INITIALIZER;

pthread_cond_t cond_susenje = PTHREAD_COND_INITIALIZER; 
pthread_cond_t cond_farbanje = PTHREAD_COND_INITIALIZER; 

int brojMestaUSusari = 0;
int brojZauzetihRadnika = 0;

void *farbaj(void *t){
    long tid = (long) t;

    int vreme = rand()%20;
    int povrsina = 1+rand()%2;
    int slojevi = 1+rand()%3;
    
    sleep(vreme);

    printf("Deo %ld je stigao u farbaru u trenutku %d.\n", tid, vreme);
    
    for(int i = 0; i < slojevi; i++)
    {
        pthread_mutex_lock(&mutex);
        
        while(brojZauzetihRadnika >= 2) pthread_cond_wait(&cond_farbanje, &mutex);
        brojZauzetihRadnika++;
        pthread_mutex_unlock(&mutex);
        
        printf("Radnik nanosi %d sloj farbe na deo %ld sledecih %d sekundi.\n", i+1, tid, povrsina);
        sleep(povrsina);
        
        pthread_mutex_lock(&mutex);
        brojZauzetihRadnika--;
        pthread_cond_broadcast(&cond_farbanje);

        while(brojMestaUSusari >= X) pthread_cond_wait(&cond_susenje, &mutex);
        
        brojMestaUSusari++;
        pthread_mutex_unlock(&mutex);

        printf("Deo %ld se susi sledecih %d sekundi.\n", tid, S);
        sleep(S);
        printf("Sloj %d dela %ld je osusen.\n", i, tid);
        
        pthread_mutex_lock(&mutex);
        brojMestaUSusari--;
        pthread_cond_broadcast(&cond_susenje);
        
        pthread_mutex_unlock(&mutex);
    }
}

int main(){
    
    pthread_t niti[P];
    
    long i;

    for(i = 0; i < P; i++){
     pthread_create(niti+i,NULL,farbaj,(void*)i);
    }
    
    for(i = 0; i < P; i++){
        pthread_join(niti[i],NULL);
    }

    pthread_mutex_destroy(&mutex);
    //pthread_mutex_destroy(&mutex_susenje);

    pthread_cond_destroy(&cond_farbanje);
    pthread_cond_destroy(&cond_susenje);

    return 0;
}