#include<stdio.h>
#include<pthread.h>
#include<stdlib.h>
#include<unistd.h>

#define N 5 // BROJ DELOVA
#define S 3 // TRAJANJE SUSENJA
#define X 2 // BROJ MESTA U SUSARI
#define BROJ_RADNIKA 2

int susara = 0;
int radnici_flag[BROJ_RADNIKA];

pthread_mutex_t mutex;
pthread_cond_t cond;

pthread_mutex_t radnici[BROJ_RADNIKA];
pthread_cond_t radnici_cond[BROJ_RADNIKA];

void *farbaj(void *arg)
{
    long id = (long)arg;

    int vreme_dolaska_u_farbaru = rand() % 10;
    int povrsina_dela = rand() % 5 + 1;
    int broj_slojeva = rand() % 3 + 1;
    int radnik = rand() % BROJ_RADNIKA;

    sleep(vreme_dolaska_u_farbaru);

    printf("Deo %ld je dosao  u farbaru kod %d radnika u trenutku %d ima povrsinu %d i na njega je potrebno naneti %d slojeva\n"
        , id, radnik, vreme_dolaska_u_farbaru, povrsina_dela, broj_slojeva);

    int vreme_za_nanosenje_farbe = povrsina_dela * broj_slojeva;

    pthread_mutex_lock(&radnici[radnik]);
    while (radnici_flag[radnik] > 0) pthread_cond_wait(&radnici_cond[radnik], &radnici[radnik]);
    printf("Radnik %d pocinje nanosenje slojeva na deo %ld i trajace %d s\n", radnik, id, vreme_za_nanosenje_farbe);
    radnici_flag[radnik] = 1;
    sleep(vreme_za_nanosenje_farbe);

    printf("Radnik %d je zavrsion nanosenje farbe za deo %ld\n", radnik, id);
    radnici_flag[radnik] = 0;
    pthread_cond_broadcast(&radnici_cond[radnik]);
    pthread_mutex_unlock(&radnici[radnik]);

    pthread_mutex_lock(&mutex);
    while (susara == X)
        pthread_cond_wait(&cond, &mutex);

    susara++;
    printf("Deo je %ld je u susari i susenje ce trajati %d s\n", id, S);
    pthread_mutex_unlock(&mutex);

    sleep(S);

    pthread_mutex_lock(&mutex);
    susara--;
    printf("Gotovo je susenje za deo %ld \n", id);
    pthread_cond_broadcast(&cond);
    pthread_mutex_unlock(&mutex);

    pthread_exit(NULL);
}

int main()
{
    pthread_t threads[N];

    pthread_mutex_init(&mutex, NULL);
    pthread_cond_init(&cond, NULL);

    for (int i = 0; i < BROJ_RADNIKA; i++)
    {
        radnici_flag[i] = 0;
        pthread_mutex_init(&radnici[i], NULL);
        pthread_mutex_init(&radnici[i], NULL);

        pthread_cond_init(&radnici_cond[i], NULL);
        pthread_cond_init(&radnici_cond[i], NULL);
    }
    
    for (long i = 0; i < N; i++)
        pthread_create(&threads[i], NULL, farbaj, (void*)i);

    for (long i = 0; i < N; i++)
        pthread_join(threads[i], NULL);

    pthread_mutex_destroy(&mutex);
    pthread_cond_destroy(&cond);
    
    for (int i = 0; i < BROJ_RADNIKA; i++)
    {
        pthread_mutex_destroy(&radnici[i]);
        pthread_mutex_destroy(&radnici[i]);
        
        pthread_cond_destroy(&radnici_cond[i]);
        pthread_cond_destroy(&radnici_cond[i]);
    }
    return 0;
}