#include <pthread.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <time.h>


#define brDelovaUSusari 3 // kapacitet susare
#define susenje 4 // bn sekundi susenja u susari
#define brDelova 12 // ukupno delova
#define brRadnika 2

pthread_mutex_t mutex;
pthread_cond_t condRadnik;
pthread_cond_t condSusara;

int susara = 0;

int radnik = 0;

void* work(void* arg){

    long id = (long) arg;

    int t = rand() % 5;
    int p = rand() % 8;
    int k = 1 + rand() % 3; 
    
    // Moze da se ofarba deo ako u susari nema mesta
    printf("Deo %ld sa povrsinom %d i potrebnim slojevima %d, je STIGAO U FARBARU u vremenskom trenutku %d\n", id, p, k, t);
    sleep(t);
    
    while(k != 0) {
        pthread_mutex_lock(&mutex);
        while(radnik == brRadnika){ // Ukoliko nema slobodnih radnika
            // printf("Deo %ld ceka nema radnika\n", id);    
            pthread_cond_wait(&condRadnik, &mutex);
        }

        radnik++;
        
        pthread_mutex_unlock(&mutex);

        printf("Deo %ld sa povrsinom %d i potrebnim slojevima %d, POCINJE SA FARBANJEM\n", id, p, k);

        sleep(p);
        k--;

        printf("Deo %ld sa povrsinom %d i potrebnim slojevima %d, JE OFARBAN\n", id, p, k);  


        pthread_mutex_lock(&mutex);
        
        radnik--;
        pthread_cond_broadcast(&condRadnik);
        
        pthread_mutex_unlock(&mutex);

        pthread_mutex_lock(&mutex);
        while(susara == brDelovaUSusari){ // Ukoliko nema mesta u susari
            // printf("Deo %ld ceka nema mesta u susari\n", id);
            pthread_cond_wait(&condSusara, &mutex);
        }

        susara++;
        pthread_mutex_unlock(&mutex);

        printf("Deo %ld sa povrsinom %d i potrebnim slojevima %d, IDE U SUSARU\n", id, p, k);    

        sleep(susenje);

        pthread_mutex_lock(&mutex);
        
        susara--;
        pthread_cond_broadcast(&condSusara);
        
        pthread_mutex_unlock(&mutex);

        printf("Deo %ld sa povrsinom %d i potrebnim slojevima %d, IZLAZI IZ SUSARE\n", id, p, k);    
    }

    // printf("DEO %ld je zavrsen\n", id);
    pthread_exit(NULL);
}

int main(){

    pthread_mutex_init(&mutex, NULL);
    pthread_cond_init(&condRadnik, NULL);
    pthread_cond_init(&condSusara, NULL);
    pthread_t threads[brDelova];

    for(long i=1; i<=brDelova; i++){
        pthread_create(&threads[i], NULL, work, (void*)i);
    }


    for(long i=1; i<=brDelova; i++){
        pthread_join(threads[i], NULL);
    }

    
    pthread_exit(NULL);

}
