#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <pthread.h>

#define BROJ_DELOVA 20
#define VREME_SUSENJA 5
#define KAPACITET_SUSARE 10

int zauzetostRadnika[] = {0, 0}; //0 slobodan, 1 zauzet
int brojDelovaUSusari = 0;

pthread_mutex_t mutex;
pthread_cond_t condRadnici;
pthread_cond_t condSusara;

void* farbanje(void* i){
	long tid = (long) i;
	int j;
	
	int time = rand() % 10;
	int p = rand() % 10; //povrsina
	int k = rand() % 10; //potreban broj slojeva farbe
	
	sleep(time);
	printf("Deo %ld je stigao na farbanje nakon %d vremena. Ima povrsinu %d, i treba mu %d slojeva farbe.", tid, time, p, k);
	
	for(j = 0; j < k; j++){
		printf("Deo %ld zapocinje ciklus po %d put od %d.", tid, j+1, k);
		pthread_mutex_lock(&mutex);
		while(zauzetostRadnika[0] != 0 || zauzetostRadnika[1] != 0)
			pthread_cond_wait(&condRadnici, &mutex);
		printf("Deo %ld je docekao slobodnog radnika i prelazi kod njega.", tid);
		int slobodanRadnik = 0;
		if(zauzetostRadnika[0] != 0)
			slobodanRadnik = 1;
		zauzetostRadnika[slobodanRadnik] = 1;
		pthread_mutex_unlock(&mutex);
		
		printf("Deo %ld zapocinje farbanje kod majstora %d.", tid, slobodanRadnik);
		sleep(p); //deo se farba
		printf("Deo %ld zavrsava farbanje kod majstora %d, medjutim radnik nece biti oslobodjen dok deo ne predje u susaru.", tid, slobodanRadnik);
		
		pthread_mutex_lock(&mutex);
		while(brojDelovaUSusari >= KAPACITET_SUSARE)
			pthread_cond_wait(&condSusara, &mutex);
		printf("Deo %ld je docekao slobodno mesto u susari i prelazi na susenje, a oslobadja radnika %d.", tid, slobodanRadnik);
		zauzetostRadnika[slobodanRadnik] = 0;
		brojDelovaUSusari++;
		pthread_mutex_unlock(&mutex);
		pthread_cond_broadcast(&condRadnici);
		
		sleep(VREME_SUSENJA); //deo se susi
		
		pthread_mutex_lock(&mutex);
		printf("Deo %ld je gotov sa susenjem.", tid);
		brojDelovaUSusari--;
		pthread_mutex_unlock(&mutex);
		pthread_cond_broadcast(&condSusara);
	}
	
	pthread_exit(NULL);
}

int main(int argc, char **argv)
{
	long i;
	pthread_t deloviThreads[BROJ_DELOVA];
	//pthread_attr_t attr;
	
	//pthread_attr_init(&attr);
	//ne mogu da se setim kako se pise za JOINABLE
	//pthread_attr_setdetachstate(&attr, JOINABLE);
	
	pthread_mutex_init(&mutex, NULL);
	pthread_cond_init(&condRadnici, NULL);
	pthread_cond_init(&condSusara, NULL);
	
	for(i = 0; i < BROJ_DELOVA; i++){
		pthread_create(&deloviThreads[i], NULL, farbanje, (void*) i);
	}
	
	//for(i = 0; i < BROJ_DELOVA; i++){
	//	pthread_join(&deloviThreads[i]);
	//}
	
	//pthread_cond_destroy(&condRadnici);
	//pthread_cond_destroy(&condSusara);
	//pthread_mutex_destroy(&mutex);
	//pthread_exit(NULL);

	return 0;
}

