#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>

#define BROJ_NITI 10	// delovi
#define P 2		// povrsina dela
#define R 2		// broj radnika
#define KAPACITET_SUSARE 5		// kapacitet susare

pthread_mutex_t mutex;
pthread_cond_t cond;

int radnici[R];	
int x = 0;		// x - kapacitet susare

int dajStatusRadnika(int index)
{
	return radnici[index];
}

void *farbanje(void *t)
{
	long id = (long) t;
	int sTime, j, s, k, r;	// s - sekunde u susari
							// k - slojevi farbe
							// r - random radnik
	
	sTime = rand() % 10;
	k = rand() % 3 + 1;
	s = rand() % 5;
	
	printf("Deo %ld stize u vremenskom trenutku %d.\n", id, sTime);
	sleep(sTime);
		
	// farbanje ------------------------------------- //
	pthread_mutex_lock(&mutex);
	
	while((dajStatusRadnika(0) == 1 || dajStatusRadnika(0) == 2) && (dajStatusRadnika(1) == 1 || dajStatusRadnika(1) == 2))
	{
		// oba radnika su zauzeta
		printf("  Oba radnika su zauzeta za farbanje! Cekam (Deo %ld).\n", id);
		pthread_cond_wait(&cond, &mutex);
	}
	
	r = rand() % R;
	radnici[r] = 1;
	
	pthread_mutex_unlock(&mutex);
	// ------------------------------------------ //
	
	
	for(j = 0; j < k; j++)
	{
		printf("	Radnik farba deo %ld - %ds, sloj %d od %d.\n", id, P, (j + 1), k);
		sleep(P);
	}
	
	// radnik je ofarbao -------------------------- //
	pthread_mutex_lock(&mutex);
	
	radnici[r] = 0;
	pthread_cond_broadcast(&cond);	// radnik je slobodan za rad
	sleep(1);
	
	pthread_mutex_unlock(&mutex);
	// ------------------------------------------ //
	
	
	// susenje ----------------------------------- //
	pthread_mutex_lock(&mutex);
	
	while((dajStatusRadnika(0) == 1 || dajStatusRadnika(0) == 2) && (dajStatusRadnika(1) == 1 || dajStatusRadnika(1) == 2))
	{
		// oba radnika su zauzeta
		printf("  Oba radnika su zauzeta za susenje! Cekam (Deo %ld).\n", id);
		pthread_cond_wait(&cond, &mutex);
	}
	
	radnici[r] = 2;
	
	while(x == KAPACITET_SUSARE)
	{
		// susara je puna
		printf("  Susara je puna! Cekam (Deo %ld).\n", id);
		pthread_cond_wait(&cond, &mutex);
	}
		
	x++;	
		
	pthread_mutex_unlock(&mutex);
	// ------------------------------------------ //
	
	
	printf("	Radnik susi deo %ld - %ds.\n", id, s);
	sleep(s);
	
	
	// radnik je osusio -------------------------- //
	pthread_mutex_lock(&mutex);
	
	radnici[r] = 0;
	x--;
	pthread_cond_broadcast(&cond);	// radnik je slobodan za rad
	sleep(1);
	
	pthread_mutex_unlock(&mutex);
	// ------------------------------------------ //
	
	pthread_exit(NULL);
}

int main()
{
	long i;
	pthread_t niti[BROJ_NITI];
	pthread_attr_t attr;
	
	srand(time(NULL));
	
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_JOINABLE);
	
	pthread_mutex_init(&mutex, NULL);
	pthread_cond_init(&cond, NULL);
	
	// radnici - 0 - slobodan, 1 - farbanje, 2 - susara
	for(i = 0; i < R; i++)
	{
		radnici[i] = 0;
	}
	
	for(i = 0; i < BROJ_NITI; i++)
	{
		pthread_create(&niti[i], &attr, farbanje, (void *) i);
	}
	
	for(i = 0; i < BROJ_NITI; i++)
	{
		pthread_join(niti[i], NULL);
	}
	
	pthread_attr_destroy(&attr);
	pthread_mutex_destroy(&mutex);
	pthread_cond_destroy(&cond);
	
	printf("Main(): Zavrsavam sa radom.\n");
	pthread_exit(NULL);
	
	return 0;
}
