#include<stdio.h>
#include<pthread.h>
#include<stdlib.h>
#include<unistd.h>

#define brProcesa 5
#define kapacitet 4
#define vremeZaSusenje 2
#define brRadnika 2

pthread_mutex_t mutex;
pthread_cond_t condSusara, condRadnici;

int brZauzetihRadnika = 0;

int popunjenaMestaUSusari = 0;

void * farbanje(void *arg)
{
    long id = (long) arg;
    int ki = 1+ rand() %4; //Moze imati max 4 sloja farbe
    int pi = 1+ rand() %3;  //Max 3 sekunde po farbanju sloja

    int ti = 1+rand() %10; //kada deo stize u farbaru;

    sleep(ti);
    printf("Deo: %ld je stigao u farbaru posle %d sek i ceka na farbanje...\n",id,ti);

    for(int i = 0; i< ki; i++)
    {
        //Farbanje
        pthread_mutex_lock(&mutex);
        while(brZauzetihRadnika == brRadnika)
            pthread_cond_wait(&condRadnici,&mutex);
        brZauzetihRadnika++;
        pthread_mutex_unlock(&mutex);
        printf("Delu %ld je ofarban %d. sloj od ukupno %d i sad ceka susenje\n",id,i+1,ki);
        sleep(pi);

        pthread_mutex_lock(&mutex);
        brZauzetihRadnika--;
        pthread_cond_broadcast(&condRadnici);
        pthread_mutex_unlock(&mutex);

        //SUSENJE
        pthread_mutex_lock(&mutex);
        while(popunjenaMestaUSusari == kapacitet)
            pthread_cond_wait(&condSusara,&mutex);
        popunjenaMestaUSusari++;
        pthread_mutex_unlock(&mutex);
        sleep(vremeZaSusenje);
        printf("Delu %ld je osusen %d. sloj od ukupno %d..\n",id,i+1,ki);

        pthread_mutex_lock(&mutex);
        popunjenaMestaUSusari--;
        pthread_cond_broadcast(&condSusara);
        pthread_mutex_unlock(&mutex);
    }

    printf("DEO %ld je kompletno ofarban i osusen.\n", id);

}


int main()
{   
    pthread_t procesi[brProcesa];

    pthread_mutex_init(&mutex, NULL);
    pthread_cond_init(&condRadnici, NULL);
    pthread_cond_init(&condSusara, NULL);

    for(long i =0; i< brProcesa; i++)
        pthread_create(procesi+i, NULL, farbanje, (void *) i);

    for(long i =0; i< brProcesa; i++)
        pthread_join(procesi[i],NULL);

    pthread_mutex_destroy(&mutex);
    pthread_cond_destroy(&condRadnici);
    pthread_cond_destroy(&condSusara);

    return 0;
}

