#include <stdio.h>
#include <pthread.h>
#include <unistd.h>
#include <stdlib.h>

#define N 10
#define x 7
#define s 1

pthread_cond_t cond_farbanje;
pthread_cond_t cond_susenje;
pthread_mutex_t mutex;
int brojDelovaUSusari = 0;
int brojDelovaUFarbari = 0;
int ofarbaniDelovi[N];
int brojOfarbanihDelova = 0;

void *susenje(void *i)
{
    long pid = (long)i;
    int t = rand() % 5 + 1;
    int k = rand() % 3 + 1;
    int p = rand() % 5 + 1;

    while(brojOfarbanihDelova <= N)
    {
        pthread_mutex_lock(&mutex);
        while (brojDelovaUSusari < x && ofarbaniDelovi[pid] == 0)
            pthread_cond_wait(&cond_susenje, &mutex);

        brojDelovaUSusari++;
        pthread_mutex_unlock(&mutex);

        sleep(s);
        printf("Deo %ld je osusen u susari nakon %ds\n", pid, s);

        pthread_mutex_lock(&mutex);
        brojDelovaUSusari--;
        ofarbaniDelovi[pid]--;
        pthread_cond_broadcast(&cond_farbanje);
        pthread_mutex_unlock(&mutex);
    }

    pthread_exit(NULL);
}

void *farbanje(void *i)
{
    long pid = (long)i;
    int t = rand() % 5 + 1;
    int k = rand() % 3 + 1;
    int p = rand() % 5 + 1;

    sleep(t);
    printf("Deo %ld sa povrsinom od %d je stigao u farbaru nakon %ds\n", pid, p, t);

    for (int i = 0; i < k; i++)
    {
        pthread_mutex_lock(&mutex);
        while(brojDelovaUFarbari != 0)
            pthread_cond_wait(&cond_farbanje, &mutex);
        brojDelovaUFarbari++;
        pthread_mutex_unlock(&mutex);
        
        
        sleep(p);
        printf("Na deo %ld sa povrsinom od %d je nanesen sloj nakon %ds\n", pid, p, p);
        
        pthread_mutex_lock(&mutex);
        ofarbaniDelovi[pid]++;
        brojDelovaUFarbari--;
        pthread_cond_broadcast(&cond_susenje);
        pthread_mutex_unlock(&mutex);
    }

    pthread_mutex_lock(&mutex);
    brojOfarbanihDelova++;
    pthread_mutex_unlock(&mutex);

    pthread_exit(NULL);
}

int main()
{
    pthread_t threads[N];

    pthread_cond_init(&cond_farbanje, NULL);
    pthread_cond_init(&cond_susenje, NULL);
    pthread_mutex_init(&mutex, NULL);

    for(long i = 0; i < N; i++)
        pthread_create(threads + i, NULL, farbanje, (void*)i);

    for(long i = 0; i < N; i++)
        pthread_create(threads + i, NULL, susenje, (void*)i);

    for(long i = 0; i < N; i++)
        pthread_join(threads[i], NULL);

    pthread_mutex_destroy(&mutex);
    pthread_cond_destroy(&cond_farbanje);
    pthread_cond_destroy(&cond_susenje);
    pthread_exit(NULL);        
}