#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<pthread.h>

/*
deo i stize u fararu u ti
deo ima povrsinu pi i ki slojeva farbe
za jedno nanosenje sloja treba pi sekundi
nakon farbe svaki deo ide u susaru na s sekundi
u susaru moze da stane x delova u jednom trenutku
dva radnika za farbanje
1 susara
povrsina 4 -> 4 sekunde se farba i 4 sekundi susi
*/

#define BR_DELOVA 4 //broj delova za farbanje
#define X 2 //kapacitet u susari

pthread_mutex_t mutex;
pthread_cond_t farbanje, susenje;

int radnici = 2; // na pocetku su oba radnika slobodna
int susara = X ; // na pocetku susara ima X slobodnih mesta
int slojevi[BR_DELOVA]; // koliko slojeva je poterbno za svaki deo i 

void *obrada(void *arg)
{
	long id = (long)arg;
	int povrsina = rand()%5 + 1;
	
	//Posle nekog vremena stize deo u farbaru
	sleep(rand()%3);
	printf("Deo: %ld, povrsina: %d, slojeva: %d\n", id, povrsina, slojevi[id]);

	while(1)
	{
		// U farbari smo sve dok ima slojeva za farbnje
		if(slojevi[id] == 0) break; 

		pthread_mutex_lock(&mutex);
		printf("Ceka farbanje id:%ld, sloj: %d\n", id, slojevi[id]);
		while(slojevi[id] > 0 && radnici == 0)
			pthread_cond_wait(&farbanje, &mutex); 
		//dokle imamo slojeva, cekamo da se radnik oslobodi
		radnici --; //radnik nije slobodan, farba nas deo
		printf("Poceto farbanje id:%ld, sloj: %d\n", id, slojevi[id]);
		pthread_mutex_unlock(&mutex);

		//farbanje sloja
		sleep(povrsina); 

		//zavrsno farbanje sloja
		pthread_mutex_lock(&mutex); 
		radnici++; //radnik je opet slobodan
		printf("Zavrseno farbanje id:%ld, sloj: %d\n", id, slojevi[id]);
		if(radnici == 1)pthread_cond_signal(&farbanje); //obavesti ako su oba bila zauzeta
		pthread_mutex_unlock(&mutex);
		
		//nakon farbanje, sledi susenje
		pthread_mutex_lock(&mutex);
		//cekamo dok u susari nema slobodnog mesta
		printf("Ceka susenje id:%ld, sloj: %d\n", id, slojevi[id]);
		while(susara == 0)
			pthread_cond_wait(&susenje, &mutex);

		printf("Poceto susenje id:%ld, sloj: %d\n", id, slojevi[id]);
		susara -- ; // zauzeli smo mesto u susari
		pthread_mutex_unlock(&mutex);

		//susenje sloja

		//zavrsavamo susenje sloja
		pthread_mutex_lock(&mutex); 
		printf("Zavrseno susenje id:%ld, sloj: %d\n", id, slojevi[id]);
		susara ++; // oslobodili smo mesto u susari
		slojevi[id] --; // skroz smo zavrsili jedan sloj
		if(susara == X - 1)pthread_cond_signal(&susenje); //obavesti ako je bila puna
		pthread_mutex_unlock(&mutex);			
		
	}	
	
}

int main()
{
	long i, k;
	pthread_t delovi[BR_DELOVA];

	pthread_mutex_init(&mutex,NULL);
	pthread_cond_init(&farbanje, NULL);
	pthread_cond_init(&susenje, NULL);

	for(i=0; i<BR_DELOVA; i++)
	{	
		pthread_create(&delovi[i],NULL, obrada, (void *)i );
		k = rand()%2 + 1;
		slojevi[i] = k;
	}

	for(i=0; i<BR_DELOVA; i++)
	{	
		pthread_join(delovi[i],NULL);
	}	

	return 0;
}
