#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>

#define N 10 // broj delova
#define S 5 // broj sekundi u susari
#define X 3 //maksimalan broj delova na susenju

pthread_mutex_t mutex_farbanje;
pthread_mutex_t mutex_susenje;
pthread_cond_t farbanje_cond;
pthread_cond_t susenje_cond;

int brojDelovaNaFarbanju = 0; //maximum 2 zbog broja farbara
int brojDelovaNaSusenju = 0; // maximum X

void *work(void *arg) {

    long id = (long) arg;
    
    int rTime = (rand() % 3) + 1; // nakon koliko sekundi deo stize na farbanje - random vrednost od 1 - 3s
    int brojSlojeva = (rand() % 5) + 1; // broj slojeva na delu koji treba da se ofarbaju - random vrednost od 1 - 5
    int vremeFarbanja = (rand() % 4) + 1; // Vreme farbanja jednog sloja(odnosno povrsina dela) - random vrednost od 1 - 3s

    int brSlojevaCopy = brojSlojeva;
    int redniBrSloja = 1;

    sleep(rTime); // Cekanje da stigne deo

    printf("Deo %ld je stigao na cekanje za farbanje, i ima %d slojeva za farbanje! \n", id, brojSlojeva);

    while(brojSlojeva) {

    pthread_mutex_lock(&mutex_farbanje);
    while(brojDelovaNaFarbanju >= 2) pthread_cond_wait(&farbanje_cond, &mutex_farbanje); // Imamo dva farbara
    brojDelovaNaFarbanju += 1;
    printf("Deo %ld je usao na farbanje %d. sloja. Trenutno delova na farbanju: %d \n", id, redniBrSloja, brojDelovaNaFarbanju);
    pthread_mutex_unlock(&mutex_farbanje);

    sleep(vremeFarbanja); // trajanje farbanja

    pthread_mutex_lock(&mutex_farbanje);
    brojDelovaNaFarbanju -= 1;
    printf("Deo %ld je izasao sa farbanja %d. sloja i ceka da ide na susenje. \n", id, redniBrSloja);
    if(brojDelovaNaFarbanju < 2) pthread_cond_broadcast(&farbanje_cond);
    pthread_mutex_unlock(&mutex_farbanje);

    sleep(1); // Pauza izmedju farbanja i susenja radi preglednosti
    
    pthread_mutex_lock(&mutex_susenje);
    while(brojDelovaNaSusenju >= X) pthread_cond_wait(&susenje_cond, &mutex_susenje);
    brojDelovaNaSusenju += 1;
    printf("Deo %ld je usao na susenje %d. sloja. Trenutno delova na susenju: %d \n", id, redniBrSloja, brojDelovaNaSusenju);
    pthread_mutex_unlock(&mutex_susenje);

    sleep(S); // trajanje susenja

    pthread_mutex_lock(&mutex_susenje);
    brojDelovaNaSusenju -= 1;
    printf("Deo %ld je izasao sa susenja %d. sloja. \n", id, redniBrSloja);
    if(brojDelovaNaSusenju < X) pthread_cond_broadcast(&susenje_cond);
    pthread_mutex_unlock(&mutex_susenje);

    brojSlojeva -= 1;
    redniBrSloja += 1;
}

    printf("Deo %ld je zavrsio sa farbanje i susenjem svojih %d slojeva! Izlazi iz programa! \n", id, brSlojevaCopy);

    pthread_exit(0);

}

int main()
{
    pthread_t delovi[N];
    pthread_mutex_init(&mutex_farbanje, NULL);
    pthread_mutex_init(&mutex_susenje, NULL);
    pthread_cond_init(&farbanje_cond, NULL);
    pthread_cond_init(&susenje_cond, NULL);

    for(long i = 0; i < N; i++) pthread_create(delovi + i, NULL, work, (void *)i);

    for(long i = 0; i < N; i++) pthread_join(delovi[i], NULL);
    
    pthread_mutex_destroy(&mutex_farbanje);
    pthread_mutex_destroy(&mutex_susenje);
    pthread_cond_destroy(&farbanje_cond);
    pthread_cond_destroy(&susenje_cond);

    pthread_exit(NULL);

    return 0;
}