#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <pthread.h>

#define DELOVI 10
#define RADNICI 2

#define DOSTUPAN 1
#define NEDOSTUPAN 0

#define KAPACITET 3

#define S 3

pthread_mutex_t mutexFarbanje = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t mutexSusara = PTHREAD_MUTEX_INITIALIZER;

pthread_cond_t condFarbanje = PTHREAD_COND_INITIALIZER;
pthread_cond_t condSusara = PTHREAD_COND_INITIALIZER;

int brojDelovaUSusari = 0;
int radnikDostupnost1 = DOSTUPAN;
int radnikDostupnost2 = DOSTUPAN;

int deloviNaCekanjuFarbanje[DELOVI];
int deloviNaCekanjuSusenje[DELOVI];
int deloviOfarbani[DELOVI];

int proveriStanjeCekanja(int *niz, int k){
    for(int i = 0; i < k;i++)
        if(niz[i] > niz[k])
            return 1;
    return 0;
}

void *farbaj(void *i){
    int oznaka = (int)i; //i
    int tI = rand()%20 + 1; //trenutak
    int pI = rand()%5 + 1; //povrsina
    int kI = rand()%5 + 1; //slojevi
    int mojRadnik = 0;
    
    sleep(tI);
    printf("Deo %d sa povrsinom %d i potrebnih slojeva %d je stigao posle %d i ceka\n", oznaka, pI, kI, tI);

    while(1){

        pthread_mutex_lock(&mutexFarbanje);
        deloviNaCekanjuFarbanje[oznaka] = tI;

        while(radnikDostupnost1 == NEDOSTUPAN || radnikDostupnost2 == NEDOSTUPAN || proveriStanjeCekanja(deloviNaCekanjuFarbanje,oznaka)){
            printf("Deo %d ceka slobodnog radnika za sloj %d\n",oznaka, deloviOfarbani[oznaka]+1);
            pthread_cond_wait(&condFarbanje, &mutexFarbanje);
        }
        if(radnikDostupnost1 == DOSTUPAN){
            radnikDostupnost1 = NEDOSTUPAN;
            mojRadnik = 1;
        }
        else{
            radnikDostupnost2 = NEDOSTUPAN;
            mojRadnik = 2;
        }

        pthread_mutex_unlock(&mutexFarbanje);

        printf("Radnik %d farba deo %d slojem %d\n", mojRadnik,oznaka, deloviOfarbani[oznaka]+1);
        sleep(pI);
        printf("Radnik %d je ofarbao sloj %d na delu %d\n", mojRadnik, deloviOfarbani[oznaka]+1, oznaka);

        pthread_mutex_lock(&mutexFarbanje);

        deloviOfarbani[oznaka]++;

        if(mojRadnik == 1)
            radnikDostupnost1 = DOSTUPAN;
        else
            radnikDostupnost2 = DOSTUPAN;
        pthread_cond_broadcast(&condFarbanje);

        pthread_mutex_unlock(&mutexFarbanje);

        pthread_mutex_lock(&mutexSusara);

        deloviNaCekanjuFarbanje[oznaka] = tI;
        while(proveriStanjeCekanja(deloviNaCekanjuSusenje,oznaka) || brojDelovaUSusari == KAPACITET){
            pthread_cond_wait(&condSusara, &mutexSusara);
        }

        brojDelovaUSusari++;
        pthread_mutex_unlock(&mutexSusara);

        printf("Deo %d se susi u susari\n", oznaka);
        sleep(S);

        pthread_mutex_lock(&mutexSusara);

        brojDelovaUSusari--;

        pthread_cond_broadcast(&condSusara);

        pthread_mutex_unlock(&mutexSusara);

        if(deloviOfarbani[oznaka] == kI){
            printf("Deo %d je potpuno ofarban i osusen.\n",oznaka);
            pthread_exit(NULL);
        }
    }
}

int main(int argc, char *argv[]){

    pthread_t threadsDelovi[DELOVI];

    for(int i = 0; i < DELOVI; i++){
        deloviOfarbani[i] = 0;
    }
    for(int i = 0; i < DELOVI;i++){
        pthread_create(threadsDelovi+i, NULL, farbaj, (void *)i);
    }
    for(int i = 0; i < DELOVI;i++){
        pthread_join(threadsDelovi[i],NULL);
    }
    pthread_exit(NULL);
}