#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>
#include<unistd.h>

#define N 3 // broj delova
#define s 3 // vreme susenja jedong dela

int x = 1; // kapacitet susare
int brRadnika = 2; // broj slobodnih radnika

pthread_mutex_t mutex;
pthread_cond_t condRadnik;
pthread_cond_t condSusara;

void *work( void *arg )
{
	long tid = ( long ) arg;
	int p = rand() % 15 + 1; // povrsina i vreme farbanja dela
	int k = rand() % 3 + 1; // broj slojeva farbe
	int trenutniSloj = 0;
	int t = rand() % 3;
	
	sleep(t);
	
	printf("Deo: %ld. sa povrsinom %d i brojem slojeva %d stize u farbaru u trenutku %d\n", tid, p, k, t);
	
	while( k > 0 )
	{
		// farbanje
		pthread_mutex_lock( &mutex );
		while( brRadnika < 1) pthread_cond_wait( &condRadnik, &mutex);
		
		brRadnika--;
		trenutniSloj++;
		k--;
		
		pthread_mutex_unlock( &mutex );
		
		printf("Deo: %ld. sloj %d. se farba %d sekundi.\n", tid, trenutniSloj, p);
		sleep(p);
		printf("Deo: %ld. sloj %d. zavrsio sa farbanjem.\n", tid, trenutniSloj);
		
		pthread_mutex_lock( &mutex );
		brRadnika++;
		pthread_cond_broadcast( &condRadnik );
		pthread_mutex_unlock( &mutex );
		// farbanje
		
		// susenje
		pthread_mutex_lock( &mutex );
		while( x < 1) pthread_cond_wait( &condSusara, &mutex);
		
		x--;
		
		pthread_mutex_unlock( &mutex );
		
		printf("Deo: %ld. sloj %d. se susi %d sekundi.\n", tid, trenutniSloj, s);
		sleep(s);
		
		printf("Deo: %ld. sloj %d. zavrsio sa susenjem.\n", tid, trenutniSloj);
		pthread_mutex_lock( &mutex );
		x++;
		pthread_cond_broadcast( &condSusara );
		pthread_mutex_unlock( &mutex );
		// susenje
	}
}

int main()
{
	
	pthread_t threads[2];
	pthread_mutex_init( &mutex, NULL );
	pthread_cond_init( &condRadnik, NULL );
	pthread_cond_init( &condSusara, NULL );
	
	for( long i = 0; i < N; i++ )
		pthread_create( &threads[i], NULL, work, ( void *)i );
		
	for( long i = 0; i < N; i++ )
		pthread_join( threads[i], NULL );
		
}
