#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <time.h>


#define BROJ_DELOVA 15 // i 
#define POVRSINA 10 // Pi
#define BROJ_SLOJEVA_FARBE 5 // Ki
#define VREME_U_SUSARI 8 // s

#define KAPACITET_SUSARE 3 // x
#define BROJ_RADNIKA 2

pthread_mutex_t mutexRadnik, mutexSusara;
pthread_cond_t cond_radnik, cond_susara;

int susara = 0;
int radnici = 2;


void* farbanje(void *arg) {
    long id = (long)arg;

    sleep(rand() % 10); // ti -> vremenski trenutak
    int pi = rand() % POVRSINA;
    int ki = rand() % BROJ_SLOJEVA_FARBE;

    printf("Deo %ld je stigao u farbaru.\n", id);
    // zauzimanje radnika
    pthread_mutex_lock(&mutexRadnik);
    while(radnici<=0) {
        pthread_cond_wait(&cond_radnik, &mutexRadnik);
    }
    int preostali_radnici = --radnici;
    pthread_mutex_unlock(&mutexRadnik); 

    int vreme_farbanja = pi*ki;
    printf("Radnik je uzeo deo %ld i farba %d sekundi. Preostali broj radnika: %d\n", id, vreme_farbanja, preostali_radnici);
    sleep(vreme_farbanja);
    printf("Radnik je ofarbao deo %ld.\n", id);

    // otpustanje radnika
    pthread_mutex_lock(&mutexRadnik);
    preostali_radnici = ++radnici;
    pthread_cond_broadcast(&cond_radnik);
    pthread_mutex_unlock(&mutexRadnik); 

    printf("Radnik koji je farbao deo %ld je slobodan. Preostali broj radnika: %d\n", id, preostali_radnici);


    // zauzimanje susare
    pthread_mutex_lock(&mutexSusara);
    while(susara>=KAPACITET_SUSARE) {
        pthread_cond_wait(&cond_susara, &mutexSusara);
    }
    int kapacitet_susare = ++susara;
    pthread_mutex_unlock(&mutexSusara); 

    int uSusari = rand() % VREME_U_SUSARI;
    printf("Deo %ld ide u susaru na %d sekundi. Popunjen kapacitet susare: %d\n", id, uSusari, kapacitet_susare);
    sleep(uSusari);
    printf("Deo %ld se osusio.\n", id);

    // izlazi iz susare 
    pthread_mutex_lock(&mutexSusara);
    kapacitet_susare = --susara;
    pthread_cond_broadcast(&cond_susara);
    pthread_mutex_unlock(&mutexSusara); 

    printf("Popunjen kapacitet susare: %d.\n", kapacitet_susare);
}


int main() {
    pthread_t delovi[BROJ_DELOVA];

    pthread_mutex_init(&mutexRadnik, NULL);
    pthread_mutex_init(&mutexSusara, NULL);

    pthread_cond_init(&cond_radnik, NULL);
    pthread_cond_init(&cond_susara, NULL);


    for(long i=0; i<BROJ_DELOVA; i++) {
        pthread_create(delovi+i, NULL, farbanje, (void*)i);
    }

    for(long i=0; i<BROJ_DELOVA; i++) {
        pthread_join(delovi[i], NULL);
    }
    

    return 0;
}