#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>
#include<unistd.h>

#define BROJ_DELOVA 25
#define MAX_T 10 // max vreme za koje stize deo u fabriku
#define MAX_P 10 // max povrsina dela
#define MAX_K 3 //  max broj slojeva farbe
#define X 3 // kapacitet susare
#define S 15 // vreme susenja delova

int broj_zauzetih_radnika = 0;
int broj_delova_u_susari = 0;

pthread_mutex_t mutexSusara, mutexRadnik;
pthread_cond_t condSusara, condRadnik;

void *farbaj(void *arg)
{
    long id = (long)arg;

    int vreme = rand() % MAX_T;
    int povrsina = rand() % MAX_P;
    int broj_slojeva = rand() % MAX_K;

    int ukupno_vreme_farbanja = povrsina*broj_slojeva;

    sleep(vreme);

    printf("Deo sa ID-em %ld CEKA da udje u farbaru u trenutku %d min \n", id, vreme);

    pthread_mutex_lock(&mutexRadnik);
        while(broj_zauzetih_radnika > 1) pthread_cond_wait(&condRadnik, &mutexRadnik);

        printf("Deo sa ID-em %ld JE USAO u farbaru u trenutku %d min \n", id, vreme);
        int tr_zauzetih_radnika = ++broj_zauzetih_radnika;
    pthread_mutex_unlock(&mutexRadnik);

    printf("broj zauzetih radnika je %d \n", tr_zauzetih_radnika); 
    printf("Delu sa ID-em %ld sledi farbanje u trajanju od %d minuta \n", id, ukupno_vreme_farbanja);

    sleep(ukupno_vreme_farbanja);

    pthread_mutex_lock(&mutexRadnik);
        printf("deo sa ID-em %ld JE OFARBAN, a broj zauzetih radnika je %d \n", id, --broj_zauzetih_radnika);
        pthread_cond_signal(&condRadnik);
    pthread_mutex_unlock(&mutexRadnik);


    printf("Deo sa ID-em %ld CEKA da udje u susaru \n", id);
    pthread_mutex_lock(&mutexSusara);
        while(broj_delova_u_susari == X) pthread_cond_wait(&condSusara, &mutexSusara);

        printf("Deo sa ID-em %ld JE USAO u susaru \n", id);
        int tr_broj_delova = ++broj_delova_u_susari;       
    pthread_mutex_unlock(&mutexSusara);

    printf("broj delova u susari je %d \n", tr_broj_delova);
    printf("deo sa ID-em %ld sledi susenje od 15 minuta \n", id);
    sleep(S);

    pthread_mutex_lock(&mutexSusara);
        printf("deo sa ID-em %ld JE OSUSEN i ide u prodaju, a broj delova u susari je %d \n", id, --broj_delova_u_susari);
        pthread_cond_signal(&condSusara);
    pthread_mutex_unlock(&mutexSusara);

}

int main()
{
    pthread_mutex_init(&mutexRadnik, NULL);
    pthread_mutex_init(&mutexSusara, NULL);
    pthread_cond_init(&condRadnik, NULL);
    pthread_cond_init(&condSusara, NULL);

    pthread_t threads[BROJ_DELOVA];

    for(long i = 0; i < BROJ_DELOVA; i++)
        pthread_create(threads+i, NULL, farbaj, (void*)i);

    for(int i = 0; i < BROJ_DELOVA; i++)
        pthread_join(threads[i], NULL);

}